SystemOrganization addCategory: 'OrbeonBPMWebBackoffice'!

SewafChildComponent subclass: #WABizagiImportReport
	instanceVariableNames: 'warnings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 17:23'!
createDescriptionColumn

	^(SewafReportColumn 
			renderBlock: [:each :html | 			
					html text: each description]
			title: 'Description')! !

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 10/10/2015 15:01'!
createSolutionColumn

	^(SewafReportColumn 
			renderBlock: [:each :html | 			
					html text: each solution]
			title: 'Solution')! !

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 17:23'!
createTitleColumn

	^(SewafReportColumn 
			renderBlock: [:each :html | 			
					html text: each title]
			title: 'Title')! !

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 17:22'!
createTypeColumn

	^(SewafReportColumn 
			renderBlock: [:each :html | 			
					html text: each type]
			title: 'Type')! !

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 17:21'!
initialize

	super initialize.

	warnings := OrderedCollection new.! !

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 07/21/2015 14:45'!
renderContentOn: html

	html div id: 'imported-xpdl-report'; class: 'unique-centered-table unique-centered-table-width70'; with: [
		html render: self reportTable.
	].

	html anchor callback: [self answer: true.];
		with: [html image  url: (SEWAFIconLibrary / #arrowback432Png); altText: 'Back to Import Processes'; title: 'Back to Import Processes'].! !

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 10/10/2015 15:00'!
reportTable

	^(SewafSelectTableReport summary: 'Warnings')
		rows: warnings; "get collection elements"
		columns: (OrderedCollection new 
						add: self createTypeColumn;
						add: self createTitleColumn;
						add: self createDescriptionColumn;
						add: self createSolutionColumn;
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

!WABizagiImportReport methodsFor: 'Accessing' stamp: 'BrunoBB 03/12/2015 17:42'!
warnings

   "Return the value of the instance variable 'warnings'."
   ^warnings! !

!WABizagiImportReport methodsFor: 'Updating' stamp: 'BrunoBB 03/12/2015 17:42'!
warnings: newValue

   "Modify the value of the instance variable 'warnings'."
   warnings := newValue! !

SEWAFWebLogin subclass: #WAOrbeonBackofficeLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAOrbeonBackofficeLogin methodsFor: 'other' stamp: 'BrunoBB 06/29/2015 16:55'!
style

	^'
h1 {margin-left: 20%;}
body {
	margin-bottom: 25px !!important;
	background-color: darkgrey;
}
#flags {
	float: right;
}
#flags img {
	margin-right: 5px;
}
#login {
	border-radius: 25px;
	padding-top: 20px;
	padding-bottom: 20px;
    width: 50%; 
    margin: 0 auto;
	background-color: lightblue;
}
#login form{
    width:50%;
	background-color: lightblue;
	margin-left: 20%;
}
#login form p{
	color: darkred;
}
#user {
	margin-bottom: 5px;
	display: inline-block;
	width: 80%;
}
#user input {
	border-radius: 15px;
	float: right;
}
#user label {
	float: left;
}
#password {
	display: inline-block;
	width: 80%;
}
#password label {
	float: left;
}
#password input {
	border-radius: 15px;
	float: right;
}
#login-button {
	float: right;
}
#login-button input {
	border-radius: 8px;
	margin-right: -20px;
}'! !

!WAOrbeonBackofficeLogin methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:43'!
tryLogin
	| logedUser |

	((self getGemStoneServerConfiguration loginModeFor: 'orbeon-processes-web') validateUser: name password: password)
	ifFalse: [^loginAttempts := loginAttempts + 1].

	logedUser := BpmUser cache at: name.

	logedUser isBackofficeUser ifFalse: [^loginAttempts := loginAttempts + 1].

	self session user: logedUser. 

	"self show: (WAOrbeonFormBackofficeUser on: logedUser)"

	self show: (WAProcessBackofficePortal on: logedUser)! !

SEWAFWebObjectComposite subclass: #BkUserLanguageComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!BkUserLanguageComposite methodsFor: 'other' stamp: 'BrunoBB 06/26/2015 14:16'!
currentDictionaryName

	^searchValues at: 'selected-language' ifAbsent: ['']! !

!BkUserLanguageComposite methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 10:42'!
renderContentOn: html

	html div id: 'internationalization'; class: 'centered-unique-form'; with: [
		html form with: [ 
			html fieldSet with: [
			html legend with: [html strong: ('Languages' translateFor: self session user)].
					html label attributeAt: 'for' put: 'language'; with: ('Select Language' translateFor: self session user).
					html select attributeAt: 'id' put: 'language'; class: '';
						list: (#(''), self getInternationalization currentDictionaries);
						callback: [:value | searchValues at: 'selected-language' put: value];
						selected: self session user currentLanguage.
					html submitButton 
						callback: [self setLanguage]; 
						with: ('Set Language' translateFor: self session user).
				].
		].
	].! !

!BkUserLanguageComposite methodsFor: 'other' stamp: 'BrunoBB 06/26/2015 14:20'!
setLanguage

	self session user setLanguage: self currentDictionaryName! !

SEWAFWebObjectComposite subclass: #BpmApplicationManagerComposite
	instanceVariableNames: 'selectedApplications appType appName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!BpmApplicationManagerComposite methodsFor: 'Accessing' stamp: 'BrunoBB 02/29/2016 09:13'!
appName
	^appName! !

!BpmApplicationManagerComposite methodsFor: 'Updating' stamp: 'BrunoBB 02/29/2016 09:13'!
appName: newValue
	appName := newValue! !

!BpmApplicationManagerComposite methodsFor: 'Accessing' stamp: 'BrunoBB 02/29/2016 09:13'!
appType
	^appType! !

!BpmApplicationManagerComposite methodsFor: 'Updating' stamp: 'BrunoBB 02/29/2016 09:13'!
appType: newValue
	appType := newValue! !

!BpmApplicationManagerComposite methodsFor: 'other' stamp: 'BrunoBB 02/29/2016 09:57'!
deleteApplication
	| application selectedApp |

	selectedApplications isEmpty ifTrue: [^self].
	selectedApp := selectedApplications last.
	(selectedApp size <= 9) ifTrue: [^self].

	application := AbstractApplication getAnyApplicationNamed: (selectedApp allButLast: 9) ifNone: [^self].

	application canDelete ifFalse: [^self].

	application removeFromCache! !

!BpmApplicationManagerComposite methodsFor: 'other' stamp: 'BrunoBB 02/29/2016 09:16'!
initialize

	super initialize.

	appType := 'BPM'.
	appName := ''.
	selectedApplications := OrderedCollection new.! !

!BpmApplicationManagerComposite methodsFor: 'other' stamp: 'BrunoBB 02/29/2016 09:11'!
newApplication

	appName isEmpty ifTrue: [^self].

	(appType = 'BPM') ifTrue: [^(BpmApplication newNamed: appName) addToCache].

	^(OrbeonApplication newNamed: appName) addToCache! !

!BpmApplicationManagerComposite methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 10:48'!
renderApplicationsListOn: html
	| apps |

	apps := self session user getBackofficeApplications.
	html label attributeAt: 'for' put: 'app-title'; with: ('Applications' translateFor: self session user).
	html multiSelect 
		class: 'height180';
		attributeAt: 'id' put: 'app-title'; 
		attributeAt: 'title' put: ('Applications' translateFor: self session user);
		list: (apps collect: [:each | each getApplicationNameForCombo]) asSortedCollection;
		size: apps size;
		callback: [:value | self selectedApplications: value].! !

!BpmApplicationManagerComposite methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 12:56'!
renderContentOn: html

	html div class: 'centered-unique-form';
		with: [
			html form with: [
				html fieldSet with:[ 
					html legend with: [html strong: ('Manage Current Applications' translateFor: self session user)].
					self renderApplicationsListOn: html.
					self renderNewApplicationOn: html.
					self renderFormOperationsOn: html.
				].
			]
	].! !

!BpmApplicationManagerComposite methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 11:02'!
renderFormOperationsOn: html

	html submitButton 
		class: 'margin-right-20per';
		callback: [self newApplication]; 
		with: ('New Application' translateFor: self session user).

	html submitButton 
		callback: [self deleteApplication]; 
		with: ('Delete Application' translateFor: self session user).! !

!BpmApplicationManagerComposite methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 09:57'!
renderNewApplicationOn: html

	Smalltalk at: #OrbeonApplication ifAbsent: [^self]. "if the Orbeon package is not installed then no need for this options"

	html label 
		attributeAt: 'for' put: 'app-type';
		with: ('Application Type' translateFor: self session user).
	html radioGroup
		callback: [:value | appType := value];
		selected: appType;
		with: [ :group |
				html label: [group radioButton value: 'BPM'. html text: 'BPM'].
				html label: [group radioButton value: 'Orbeon'. html text: 'Orbeon']].

	html label attributeAt: 'for' put: 'app-name'; with: ('Application Name' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'app-name'; callback: [:value | appName :=  value].! !

!BpmApplicationManagerComposite methodsFor: 'Accessing' stamp: 'BrunoBB 02/29/2016 09:13'!
selectedApplications
	^selectedApplications! !

!BpmApplicationManagerComposite methodsFor: 'Updating' stamp: 'BrunoBB 02/29/2016 09:13'!
selectedApplications: newValue
	selectedApplications := newValue! !

SEWAFWebObjectComposite subclass: #FormLoginModeComposite
	instanceVariableNames: 'modeType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!FormLoginModeComposite methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:43'!
initialize

	super initialize.

	modeType := (self getGemStoneServerConfiguration loginModeFor: 'orbeon-processes-web') modeName! !

!FormLoginModeComposite methodsFor: 'other' stamp: 'BrunoBB 03/16/2015 05:49'!
ldapLoginModeName

	^OrbeonLdapLogin modeName! !

!FormLoginModeComposite methodsFor: 'other' stamp: 'BrunoBB 03/16/2015 05:49'!
loginModeNames

	^Array
		with: self ldapLoginModeName
		with: OrbeonProcessWebLocalLogin modeName! !

!FormLoginModeComposite methodsFor: 'Accessing' stamp: 'BrunoBB 03/16/2015 05:48'!
modeType

   "Return the value of the instance variable 'modeType'."
   ^modeType! !

!FormLoginModeComposite methodsFor: 'Updating' stamp: 'BrunoBB 03/16/2015 05:48'!
modeType: newValue

   "Modify the value of the instance variable 'modeType'."
   modeType := newValue! !

!FormLoginModeComposite methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 10:40'!
renderContentOn: html

	html div id: 'login-mode-configuration'; class: 'centered-unique-form';
		with: [self renderLoginModeOn: html].! !

!FormLoginModeComposite methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:43'!
renderLdapOptionsOn: html

	self getGemStoneServerConfiguration setLdapFor: 'orbeon-processes-web'.
	html break.
	html label attributeAt: 'for' put: 'ldapIP'; with: ('Ldap IP' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'ldapIP'; callback: [:value | self getGemStoneServerConfiguration loginModeForProcessWeb ldapIP: value]; 
		with: self getGemStoneServerConfiguration ldapIpForWebProcess.
	html label attributeAt: 'for' put: 'dn'; with: ('Distinguished Name' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'dn'; callback: [:value | self getGemStoneServerConfiguration loginModeForProcessWeb dn: value]; 
		with: self getGemStoneServerConfiguration dnForWebProcess.
	html label attributeAt: 'for' put: 'ou'; with: ('Organizational Unit' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'ou'; callback: [:value | self getGemStoneServerConfiguration loginModeForProcessWeb ou: value]; 
		with: self getGemStoneServerConfiguration ouForWebProcess.
	html label attributeAt: 'for' put: 'bindPassword'; with: ('Bind Password' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'bindPassword'; callback: [:value | self getGemStoneServerConfiguration loginModeForProcessWeb bindPassword: value]; 
		with: self getGemStoneServerConfiguration bindPasswordForWebProcess.! !

!FormLoginModeComposite methodsFor: 'other' stamp: 'BrunoBB 06/24/2015 13:37'!
renderLoginModeOn: html

	html form with: [
		html fieldSet with:[
			html legend with: [html strong: ('Login Mode' translateFor: self session user)].
			html radioGroup
				callback: [:value | modeType := value];
				selected: modeType;
				with: [ :group |
					self loginModeNames do: [:each |
						html label: [ group radioButton onChange: 'submit()'; value: each.
							html text: each]]].
			(modeType = self ldapLoginModeName) 
			ifTrue: [self renderLdapOptionsOn: html]
			ifFalse: [self setLocalLoginMode].
			html submitButton callback: [self saveLoginMode]; with: ('Save Login Mode' translateFor: self session user).
		].
	].! !

!FormLoginModeComposite methodsFor: 'other' stamp: 'BrunoBB 03/16/2015 05:48'!
saveLoginMode! !

!FormLoginModeComposite methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:43'!
setLocalLoginMode

	self getGemStoneServerConfiguration setLocalForProcesses! !

SEWAFWebObjectComposite subclass: #FormProcessRoleComposite
	instanceVariableNames: 'selectedUser isAddingUser newUser isBackoffice isAdmin selectedApplication rolesBatchList usersWithSelectedRoleBatchList addUserToRoleBatchList rolesWithSelectedUserBatchList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!FormProcessRoleComposite methodsFor: 'other' stamp: 'BrunoBB 03/25/2014 06:15'!
answer

	super answer.

	^model! !

!FormProcessRoleComposite methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 11:49'!
booleanValueForUser: anOrbeonFormUser

	^selectedObject isGranted: anOrbeonFormUser! !

!FormProcessRoleComposite methodsFor: 'operations' stamp: 'BrunoBB 12/01/2014 04:15'!
createNewRol

	^self createNewRolIn: selectedApplication! !

!FormProcessRoleComposite methodsFor: 'operations' stamp: 'BrunoBB 03/09/2016 12:38'!
createNewRolIn: anAbstractApplication

	anAbstractApplication ifNil: [^self].

	model addToCacheInAppName: anAbstractApplication applicationName.
	model application: anAbstractApplication.

	rolesBatchList add: model.

	model := (isBackoffice ifTrue: [BpmBackofficeRole] ifFalse: [BpmFrontOfficeRole]) new.

	"^self answer."! !

!FormProcessRoleComposite methodsFor: 'other' stamp: 'BrunoBB 03/11/2016 11:26'!
initialize

	super initialize.

	isAddingUser := false.
	isBackoffice := false.
	isAdmin := false.
	newUser := BpmUser new.

	self initializeBatchedLists.

	self setShowToElementNamed: 'search-area'. "the search-are is shown by default"! !

!FormProcessRoleComposite methodsFor: 'other' stamp: 'BrunoBB 03/10/2016 06:52'!
initializeBatchedLists

	rolesBatchList := SewafBatchedList parentComponent: self.
	rolesBatchList batchSize: 10;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.

	usersWithSelectedRoleBatchList := SewafBatchedList parentComponent: self.
	usersWithSelectedRoleBatchList batchSize: 10;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.

	addUserToRoleBatchList := SewafBatchedList parentComponent: self.
	addUserToRoleBatchList batchSize: 10;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom-with-button'.

	rolesWithSelectedUserBatchList := SewafBatchedList parentComponent: self.
	rolesWithSelectedUserBatchList batchSize: 10;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.! !

!FormProcessRoleComposite methodsFor: 'Accessing' stamp: 'BrunoBB 09/12/2014 17:23'!
isAddingUser

   "Return the value of the instance variable 'isAddingUser'."
   ^isAddingUser! !

!FormProcessRoleComposite methodsFor: 'Updating' stamp: 'BrunoBB 09/12/2014 17:23'!
isAddingUser: newValue

   "Modify the value of the instance variable 'isAddingUser'."
   isAddingUser := newValue! !

!FormProcessRoleComposite methodsFor: 'Accessing' stamp: 'BrunoBB 09/17/2014 06:12'!
isAdmin

   "Return the value of the instance variable 'isAdmin'."
   ^isAdmin! !

!FormProcessRoleComposite methodsFor: 'Updating' stamp: 'BrunoBB 09/17/2014 06:12'!
isAdmin: newValue

   "Modify the value of the instance variable 'isAdmin'."
   isAdmin := newValue! !

!FormProcessRoleComposite methodsFor: 'Accessing' stamp: 'BrunoBB 09/16/2014 07:19'!
isBackoffice

   "Return the value of the instance variable 'isBackoffice'."
   ^isBackoffice! !

!FormProcessRoleComposite methodsFor: 'other' stamp: 'BrunoBB 12/18/2015 14:23'!
isBackoffice: aBoolean

	aBoolean ifFalse: [model := model asFrontofficeRole].

	aBoolean ifTrue: [model := model asBackofficeRole].

	isBackoffice := aBoolean! !

!FormProcessRoleComposite methodsFor: 'operations' stamp: 'BrunoBB 03/09/2016 13:38'!
modifyUser: user value: aBoolean

	isAddingUser := false.

	aBoolean ifFalse: [^self].

	usersWithSelectedRoleBatchList add: user.

	^selectedObject grantUser: user! !

!FormProcessRoleComposite methodsFor: 'operations' stamp: 'BrunoBB 06/24/2015 13:07'!
newRemoveRolButton

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html anchor callback: [self removeRol: each]; 
								with: [html image url: (SEWAFFileLibrary / #remove24Png); 
														title: ('Remove Role' translateFor: self session user); 
														altText: ('Remove Role' translateFor: self session user).]] 
				title: 'DEL') sortBlock: nil; 
				cssClass: 'width-6-percent';
			yourself! !

!FormProcessRoleComposite methodsFor: 'operations' stamp: 'BrunoBB 06/24/2015 13:19'!
newRemoveRolFromUserButton

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html anchor callback: [self removeRoleFromUser: each]; 
								with: [html image url: (SEWAFFileLibrary / #remove24Png); 
														title: ('Remove User Role' translateFor: self session user); 
														altText: ('Remove User Role' translateFor: self session user).]] 
				title: 'DEL') sortBlock: nil; 
			cssClass: 'width-6-percent';
			yourself! !

!FormProcessRoleComposite methodsFor: 'operations' stamp: 'BrunoBB 06/24/2015 13:19'!
newRemoveUserFromRolButton

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html anchor callback: [self removeUserFromRole: each]; 
								with: [html image url: (SEWAFFileLibrary / #remove24Png); 
														title: ('Remove User from Role' translateFor: self session user); 
														altText: ('Remove User from Role' translateFor: self session user).]] 
				title: 'DEL') sortBlock: nil; 
			cssClass: 'width-6-percent';
			yourself! !

!FormProcessRoleComposite methodsFor: 'Accessing' stamp: 'BrunoBB 09/12/2014 05:49'!
newUser

   "Return the value of the instance variable 'newUser'."
   ^newUser! !

!FormProcessRoleComposite methodsFor: 'Updating' stamp: 'BrunoBB 09/12/2014 05:49'!
newUser: newValue

   "Modify the value of the instance variable 'newUser'."
   newUser := newValue! !

!FormProcessRoleComposite methodsFor: 'operations' stamp: 'BrunoBB 03/09/2016 13:12'!
removeRol: aBpmRole

	aBpmRole canDelete ifFalse: [^self inform: ('Role can not be deleted' translateFor: self session user)].

	rolesBatchList remove: aBpmRole.
	
	^aBpmRole removeFromCacheInAppName: aBpmRole getApplicationName! !

!FormProcessRoleComposite methodsFor: 'operations' stamp: 'BrunoBB 03/09/2016 13:36'!
removeRoleFromUser: aBpmRole

	aBpmRole ungrantUser: selectedUser.

	rolesWithSelectedUserBatchList remove: aBpmRole.! !

!FormProcessRoleComposite methodsFor: 'operations' stamp: 'BrunoBB 03/09/2016 13:22'!
removeUserFromRole: aBpmUser

	selectedObject ungrantUser: aBpmUser.

	rolesWithSelectedUserBatchList remove: aBpmUser.! !

!FormProcessRoleComposite methodsFor: 'other' stamp: 'BrunoBB 03/09/2016 13:27'!
renderAddingUserOn: html

	html div id: 'users-to-add'; class: 'default-gray-table ';
		with:[addUserToRoleBatchList items: (BpmUser cache reject: [:each | selectedObject isGranted: each]) asArray.
				html render: (addUserToRoleBatchList table: self sewafTableForUsers).].! !

!FormProcessRoleComposite methodsFor: 'other' stamp: 'BrunoBB 06/24/2015 13:21'!
renderAddUserButtonOn: html

	html anchor callback: [self switchAddingUser];
					with: [html image url: (SEWAFFileLibrary / #useradd24iconPng); 
											altText: ('Add User to Rol' translateFor: self session user); 
											title: ('Add User to Rol' translateFor: self session user)].! !

!FormProcessRoleComposite methodsFor: 'other' stamp: 'BrunoBB 03/10/2016 08:50'!
renderApplicationComboOn: html

	html select 
		attributeAt: 'id' put: 'application';
		list: #(' '), (self session user getBackofficeApplications collect: [:each | each getApplicationNameForCombo]) asSortedCollection; 
		callback: [:value | 
			selectedApplication :=  (value size > 9) 
				ifTrue: [self getApplicationManagerClass getAnyApplicationNamed: (value allButLast: 9)]
				ifFalse: [nil].
		];
		selected: (selectedApplication ifNotNil: [selectedApplication getApplicationNameForCombo] ifNil: ['']).! !

!FormProcessRoleComposite methodsFor: 'other' stamp: 'BrunoBB 03/11/2016 11:31'!
renderContentOn: html

	html div id: 'top-search-area'; class: 'top-search-area-box-shadow'; with: [self renderNewRoleFormOn: html].

	html div id: 'system-rols'; class: 'default-gray-table '; with:[html render: (rolesBatchList table: self sewafTableForRoles).].
	selectedObject ifNil: [^self].
	isAddingUser ifTrue: [^self renderAddingUserOn: html].
	html div id: 'add-user-button'; with: [self renderAddUserButtonOn: html].

	html div id: 'rols-and-users'; with: [
			html div id: 'rols-users'; class: 'default-gray-table ';
				with:[usersWithSelectedRoleBatchList items: selectedObject users asArray.
							html render: (usersWithSelectedRoleBatchList table: self sewafTableUsersWithRol)].
			selectedUser ifNotNil: [
				html div id: 'user-rols'; class: 'default-gray-table ';
					with:[rolesWithSelectedUserBatchList items: selectedUser roles.
								html render: (rolesWithSelectedUserBatchList table: self sewafTableRolsOfUser).]]].! !

!FormProcessRoleComposite methodsFor: 'other' stamp: 'BrunoBB 03/12/2016 14:59'!
renderNewRoleFormOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	html div 
		with: [html form with: [
					html fieldSet with: [
						html legend class: 'top-search-legend'; 
							with: ('Create-Search Roles' translateFor: self session user).
						html div class: 'top-search-div'; with: [
							html label attributeAt: 'for' put: 'rolename'; with: ('Rol''s Name' translateFor: self session user).
							html textInput attributeAt: 'id' put: 'rolename'; callback: [:value | model name: value].
						].
						html div class: 'top-search-div'; with: [
							html label attributeAt: 'for' put: 'application'; with: ('Application' translateFor: self session user).
							self renderApplicationComboOn: html.
						].
						html div class: 'top-search-div'; style: 'width: 235px; margin-top: 18px;'; with: [
							html checkbox attributeAt: 'id' put: 'isadmin'; callback: [:value | self model isAdmin: value].
							html label attributeAt: 'for' put: 'isadmin'; with: ('Is Admin ?' translateFor: self session user).
							html checkbox attributeAt: 'id' put: 'isbackoffice'; callback: [:value | self isBackoffice: value].
							html label attributeAt: 'for' put: 'isbackoffice'; with: ('Is Backoffice ?' translateFor: self session user).
						].
						html div id: 'top-search-filters-one'; with: [
							html submitButton style: 'margin-top: 25px;';
								callback: [self searchRoles]; 
								with: ('Search' translateFor: self session user).
							html submitButton 
								callback: [self createNewRolIn: selectedApplication]; 
								with: ('Create Role' translateFor: self session user)]
					]
				]
		].! !

!FormProcessRoleComposite methodsFor: 'searching' stamp: 'BrunoBB 03/10/2016 08:49'!
searchByApplication
	| roles |

	selectedApplication ifNil: [^self].

	roles := BpmRole getRolsInApp: selectedApplication.

	model isAdmin ifTrue: [roles := roles select: [:each | each isAdmin]].
	model isBackofficeRole ifTrue: [roles := roles select: [:each | each isBackofficeRole]].

	rolesBatchList items: roles.
	
	^roles! !

!FormProcessRoleComposite methodsFor: 'searching' stamp: 'BrunoBB 03/10/2016 06:51'!
searchByName

	^rolesBatchList items: (self session user getVisibleRoles select: [:each | each name = model name])! !

!FormProcessRoleComposite methodsFor: 'searching' stamp: 'BrunoBB 03/10/2016 06:56'!
searchRoles
	| roles |

	selectedObject := nil.

	model name notEmpty ifTrue: [^self searchByName].

	selectedApplication ifNotNil: [^self searchByApplication].

	roles :=  self session user getVisibleRoles.

	model isAdmin ifTrue: [roles := roles select: [:each | each isAdmin]].
	model isBackofficeRole ifTrue: [roles := roles select: [:each | each isBackofficeRole]].

	rolesBatchList items: roles.
	
	^roles! !

!FormProcessRoleComposite methodsFor: 'Accessing' stamp: 'BrunoBB 09/16/2014 07:23'!
selectedApplication

   "Return the value of the instance variable 'selectedApplication'."
   ^selectedApplication! !

!FormProcessRoleComposite methodsFor: 'Updating' stamp: 'BrunoBB 09/16/2014 07:23'!
selectedApplication: newValue

   "Modify the value of the instance variable 'selectedApplication'."
   selectedApplication := newValue! !

!FormProcessRoleComposite methodsFor: 'Accessing' stamp: 'BrunoBB 09/12/2014 16:22'!
selectedUser

   "Return the value of the instance variable 'selectedUser'."
   ^selectedUser! !

!FormProcessRoleComposite methodsFor: 'Updating' stamp: 'BrunoBB 09/12/2014 16:22'!
selectedUser: newValue

   "Modify the value of the instance variable 'selectedUser'."
   selectedUser := newValue! !

!FormProcessRoleComposite methodsFor: 'tables' stamp: 'BrunoBB 03/09/2016 12:34'!
sewafTableForRoles

	^(SewafSelectTableReport summary: 'Assigned Roles')
		"rows: self searchRoles; "
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #name title: 'Rol' onClick: [:each | selectedObject := each. selectedUser := nil]);
						add: (SewafReportColumn selector: #getApplicationName title: 'Application');
						add: (SewafReportColumn selector: #isBackofficeRole title: 'Is Backoffice User');
						add: (SewafReportColumn selector: #isAdmin title: 'Is Admin');
						"add: self addCurrentUserButton;"
						add: self newRemoveRolButton;
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		selectedObject:  selectedObject;
		yourself! !

!FormProcessRoleComposite methodsFor: 'tables' stamp: 'BrunoBB 03/09/2016 13:18'!
sewafTableForUsers
	"Table with all Users that are NOT present in the role <selectedObject> "

	^(SewafBooleanSelectTable parent: self)
		summary: 'Users to Assign';
		buttonLabel: ('Assign and Close' translateFor: self session user);
		booleanSelector: #booleanValueForUser:;
		callbackSelector: #modifyUser:value:;
		"rows: (BpmUser cache reject: [:each | selectedObject isGranted: each]) asArray; "
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #username title: 'Username');
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

!FormProcessRoleComposite methodsFor: 'tables' stamp: 'BrunoBB 03/09/2016 13:29'!
sewafTableRolsOfUser

	^(SewafTableReport summary: 'Users')
		"rows: selectedUser roles; "
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #name title: 'Rol');
						add: self newRemoveRolFromUserButton;
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

!FormProcessRoleComposite methodsFor: 'tables' stamp: 'BrunoBB 03/09/2016 13:27'!
sewafTableUsersWithRol

	^(SewafSelectTableReport summary: 'Users')
		"rows: selectedObject users asArray; "
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #username title: 'Username' onClick: [:each | selectedUser := each]);
						add: self newRemoveUserFromRolButton;
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		selectedColor: 'rgb(235, 172, 95)';
		selectedObject: selectedUser;
		yourself! !

!FormProcessRoleComposite methodsFor: 'other' stamp: 'BrunoBB 09/12/2014 17:32'!
switchAddingUser

	isAddingUser := isAddingUser not! !

SEWAFWebObjectComposite subclass: #FormProcessUserComposite
	instanceVariableNames: 'isAddingRol resetPasswords usersBatchedList userRolesBatchedList addRoleBatchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!FormProcessUserComposite methodsFor: 'other' stamp: 'BrunoBB 12/10/2015 11:48'!
booleanValueForRol: anOrbeonFormRole

	^anOrbeonFormRole isGranted: selectedObject! !

!FormProcessUserComposite methodsFor: 'operations' stamp: 'BrunoBB 03/09/2016 11:44'!
createNewUser

	model addToCache.

	usersBatchedList add: model.	

	model := BpmUser new.

	^self answer! !

!FormProcessUserComposite methodsFor: 'other' stamp: 'BrunoBB 03/11/2016 11:20'!
initialize

	super initialize.

	isAddingRol := false.
	model := BpmUser new.
	resetPasswords := Dictionary new.

	self initializeBatchedLists.

	self setShowToElementNamed: 'search-area'. "the search-are is shown by default"! !

!FormProcessUserComposite methodsFor: 'other' stamp: 'BrunoBB 03/10/2016 06:39'!
initializeBatchedLists

	usersBatchedList := SewafBatchedList parentComponent: self.
	usersBatchedList batchSize: 10;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.

	userRolesBatchedList := SewafBatchedList parentComponent: self.
	userRolesBatchedList batchSize: 10;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.

	addRoleBatchedList := SewafBatchedList parentComponent: self.
	addRoleBatchedList batchSize: 2;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom-with-button'.! !

!FormProcessUserComposite methodsFor: 'Accessing' stamp: 'BrunoBB 10/10/2014 05:51'!
isAddingRol

   "Return the value of the instance variable 'isAddingRol'."
   ^isAddingRol! !

!FormProcessUserComposite methodsFor: 'Updating' stamp: 'BrunoBB 10/10/2014 05:51'!
isAddingRol: newValue

   "Modify the value of the instance variable 'isAddingRol'."
   isAddingRol := newValue! !

!FormProcessUserComposite methodsFor: 'operations' stamp: 'BrunoBB 03/09/2016 11:53'!
modifyRole: rol value: aBoolean

	isAddingRol := false.

	aBoolean ifFalse: [^self].

	addRoleBatchedList add: selectedObject.

	^rol grantUser: selectedObject! !

!FormProcessUserComposite methodsFor: 'operations' stamp: 'BrunoBB 06/24/2015 12:55'!
newRemoveRolFromUserButton

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html anchor callback: [self removeRolFromUser: each]; 
								with: [html image url: (SEWAFFileLibrary / #remove24Png); 
														title: ('Remove Role from User' translateFor: self session user); 
														altText: ('Remove Role from User' translateFor: self session user).]] 
				title: 'DEL') sortBlock: nil; 
				cssClass: 'width-6-percent';
			yourself! !

!FormProcessUserComposite methodsFor: 'operations' stamp: 'BrunoBB 03/09/2016 11:49'!
removeRolFromUser: aBpmRole

	userRolesBatchedList remove: aBpmRole.

	^aBpmRole ungrantUser: selectedObject! !

!FormProcessUserComposite methodsFor: 'operations' stamp: 'BrunoBB 03/09/2016 11:44'!
removeUser: aBpmUser

"	aBpmUser canDelete ifFalse: [^self inform: ('User can not be deleted' translateFor: self session user)]."

	usersBatchedList remove: aBpmUser.

	^aBpmUser removeFromCache! !

!FormProcessUserComposite methodsFor: 'operations' stamp: 'BrunoBB 07/21/2015 14:56'!
removeUserButton

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html anchor callback: [self removeUser: each]; 
								with: [html image url: (SEWAFIconLibrary / #remove24Png); 
														title: ('Remove User' translateFor: self session user); 
														altText: ('Remove User' translateFor: self session user).]] 
				title: 'DEL') sortBlock: nil; 
				cssClass: 'width-6-percent';
			yourself! !

!FormProcessUserComposite methodsFor: 'other' stamp: 'BrunoBB 03/09/2016 03:53'!
renderAddingRolOn: html

	html div id: 'users-to-add-to-role'; class: 'default-gray-table ';
		with:[addRoleBatchedList items: (self session user getVisibleRoles difference: selectedObject roles).
				html render: (addRoleBatchedList table: self sewafTableForRols).].! !

!FormProcessUserComposite methodsFor: 'other' stamp: 'BrunoBB 06/24/2015 12:59'!
renderAddRolButtonOn: html

	html anchor callback: [self switchAddingUser];
					with: [html image url: (SEWAFFileLibrary / #useradd24iconPng); 
											altText: ('Add Role to User' translateFor: self session user); 
											title: ('Add Role to User' translateFor: self session user)].! !

!FormProcessUserComposite methodsFor: 'other' stamp: 'BrunoBB 03/10/2016 09:09'!
renderContentOn: html

	html div id: 'top-search-area'; class: 'top-search-area-box-shadow';
		with: [self renderSearchAndNewFormOn: html].
	html div id: 'users-configuration'; with: [
		html div id: 'system-users'; class: 'default-gray-table ';
			with:[html render: (usersBatchedList table: self sewafTableForUsers)].
		selectedObject ifNil: [^self].
		isAddingRol ifTrue: [^self renderAddingRolOn: html].
		html div id: 'add-rol-button'; 
			with: [self renderAddRolButtonOn: html].

		html div id: 'users-and-rols'; with: [
				html div class: 'default-gray-table ';
					with:[userRolesBatchedList items: selectedObject roles.
							html render:  (userRolesBatchedList table: self sewafTableRolsOfUser).]]].! !

!FormProcessUserComposite methodsFor: 'other' stamp: 'BrunoBB 03/12/2016 14:57'!
renderNewFormOn: html

	html form with: [
		html fieldSet with: [
			html legend class: 'top-search-legend'; 
				with: ('Create User' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'username'; with: ('User Name' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'username'; callback: [:value | model username: value].
			].
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'password'; with: ('Password' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'password'; callback: [:value | model password: value].
			].
			html div id: 'top-search-filters-one'; with: [
				html submitButton 
					style: 'margin-top: 25px;';
					callback: [self createNewUser]; 
					with: ('Create User' translateFor: self session user)]
		]
	]! !

!FormProcessUserComposite methodsFor: 'other' stamp: 'BrunoBB 03/11/2016 11:25'!
renderSearchAndNewFormOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	html div id: 'newUserForm'; class: 'float-left'; with: [self renderNewFormOn: html].

	html div class: 'top-search-vertical-line'.

	html div id: 'searchUserForm'; with: [self renderSearchFormOn: html].! !

!FormProcessUserComposite methodsFor: 'other' stamp: 'BrunoBB 03/12/2016 14:57'!
renderSearchFormOn: html

	html form with: [
		html fieldSet with: [
			html legend class: 'top-search-legend'; 
				with: ('Search User' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'username'; with: ('User Name' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'username'; callback: [:value | self addSearchValue: value named: 'username'].
			].
			html div id: 'top-search-filters-one'; with: [
				html submitButton 
					style: 'margin-top: 25px;';
					callback: [self searchUser]; 
					with: ('Search' translateFor: self session user)]
		]
	]! !

!FormProcessUserComposite methodsFor: 'other' stamp: 'BrunoBB 07/21/2015 14:59'!
resetPasswordButton

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html anchor callback: [self resetPasswordOf: each]; 
								with: [html image url: (SEWAFIconLibrary / #actionseditclear24Png); 
														title: ('Reset Password' translateFor: self session user); 
														altText: ('Reset Password' translateFor: self session user).]] 
				title: 'RP') sortBlock: nil; 
				cssClass: 'width-6-percent';
			yourself! !

!FormProcessUserComposite methodsFor: 'other' stamp: 'BrunoBB 07/21/2015 15:13'!
resetPasswordOf: anOrbeonFormUser

	resetPasswords at: anOrbeonFormUser username put: anOrbeonFormUser resetPassword! !

!FormProcessUserComposite methodsFor: 'searching' stamp: 'BrunoBB 03/10/2016 07:08'!
searchUser

	selectedObject := nil.

	(self hasSearchValueAt: 'username') 
	ifFalse: [^usersBatchedList items: (self session user getVisibleUsers asSortedCollection: [:a : b | a username <= b username])].

	usersBatchedList items: 
		(((self searchValueAt: 'username') includes: $*)
		ifTrue: [self session user getVisibleUsers select: [:each | (self searchValueAt: 'username') match: each username]]
		ifFalse: [self session user getVisibleUsers at: (self searchValueAt: 'username') ifAbsent: [#()]])! !

!FormProcessUserComposite methodsFor: 'tables' stamp: 'BrunoBB 03/09/2016 03:46'!
sewafTableForRols
	"Table with all Users that are NOT present in the role <selectedObject> "

	^(SewafBooleanSelectTable parent: self)
		summary: 'Users to Assign';
		buttonLabel: ('Assign and Close' translateFor: self session user);
		booleanSelector: #booleanValueForRol:;
		callbackSelector: #modifyRole:value:;
		"rows: (self session user getVisibleRoles difference: selectedObject roles); "
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #name title: 'Role');
						add: (SewafReportColumn selector: #getApplicationName title: 'Application');
						add: (SewafReportColumn selector: #isAdmin title: 'Admin?');
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

!FormProcessUserComposite methodsFor: 'tables' stamp: 'BrunoBB 03/09/2016 03:30'!
sewafTableForUsers
	"Table with all Users that are NOT present in the role <selectedObject> "

	^(SewafSelectTableReport parent: self)
		summary: 'Users to Assign';
		"rows: self session user getVisibleUsers; "
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #username title: 'Username' onClick: [:each | selectedObject := each]);
						add: (SewafReportColumn selector: #isAdmin title: 'Admin?');
						add: (SewafReportColumn selector: #printResetedPassword title: 'Reseted Password');
						add: self resetPasswordButton;
						add: self removeUserButton;
						yourself);
		rowColors: #(white white);
		selectedObject: selectedObject;
		rowPeriod: 1;
		yourself! !

!FormProcessUserComposite methodsFor: 'tables' stamp: 'BrunoBB 03/09/2016 03:42'!
sewafTableRolsOfUser

	^(SewafTableReport summary: 'Users')
		"rows: selectedObject roles; "
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #name title: 'Role');
						add: (SewafReportColumn selector: #isAdmin title: 'Admin');
						add: (SewafReportColumn selector: #isBackofficeRole title: 'Backoffice');
						add: (SewafReportColumn selector: #getApplicationName title: 'Application');
						add: self newRemoveRolFromUserButton;
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

!FormProcessUserComposite methodsFor: 'other' stamp: 'BrunoBB 09/13/2014 13:08'!
switchAddingUser

	isAddingRol := isAddingRol not! !

SEWAFWebObjectComposite subclass: #FormServerConfigurationComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!FormServerConfigurationComposite methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 12:56'!
renderContentOn: html

	html div id: 'server-configuration'; class: 'centered-unique-form'; with: [
		self session user isBackofficeUserAndAdmin 
		ifTrue: [self renderServerConfigurationFormOn: html]
		ifFalse: [self renderServerConfigurationViewOn: html].
	]! !

!FormServerConfigurationComposite methodsFor: 'other' stamp: 'BrunoBB 06/24/2015 13:29'!
renderServerConfigurationFormOn: html

	html form with: [
		html fieldSet with:[
			html legend with: [html strong: ('Servers Configuration' translateFor: self session user)].
					self renderServerConfigurationSettingOn: html.
					].
				].! !

!FormServerConfigurationComposite methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:35'!
renderServerConfigurationSettingOn: html

	html label attributeAt: 'for' put: 'databaseIP'; with: ('Database IP' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'databaseIP'; 
			callback: [:value | self getOrbeonDatabaseConfiguration databaseIP: value]; 
			with: self getOrbeonDatabaseConfiguration databaseIP.
	html label attributeAt: 'for' put: 'databaseUser'; with: ('Database User' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'databaseUser'; 
			callback: [:value | self getOrbeonDatabaseConfiguration databaseUser: value]; 
			with: self getOrbeonDatabaseConfiguration databaseUser.
	html label attributeAt: 'for' put: 'databasePassword'; with: ('Database Password' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'databasePassword'; 
			callback: [:value | self getOrbeonDatabaseConfiguration databasePassword: value]; 
			with: self getOrbeonDatabaseConfiguration databasePassword.
	html label attributeAt: 'for' put: 'orbeonIP'; with: ('Orbeon IP' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'orbeonIP'; 
			callback: [:value | self getOrbeonWebServerConfiguration orbeonIP: value]; 
			with: self getOrbeonWebServerConfiguration orbeonIP.
	html label attributeAt: 'for' put: 'gemstoneIP'; with: ('GemStone/S IP' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'gemstoneIP'; 
			callback: [:value | self getGemStoneServerConfiguration gemstoneIP: value]; 
			with: self getGemStoneServerConfiguration gemstoneIP.
	html submitButton callback: [self savePreferences]; with: ('Save Preferences' translateFor: self session user).! !

!FormServerConfigurationComposite methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:37'!
renderServerConfigurationViewOn: html

	html label with: 'Database IP'.
	html textInput 
		callback: [:value | self getOrbeonDatabaseConfiguration databaseIP: value]; 
		readonly: true; 
		with: self getOrbeonDatabaseConfiguration databaseIP.
	html label with: 'Database User'.
	html textInput 
		callback: [:value | self getOrbeonDatabaseConfiguration databaseUser: value]; 
		readonly: true; 
		with: self getOrbeonDatabaseConfiguration databaseUser.
	html label with: 'Database Password'.
	html textInput 
		callback: [:value | self getOrbeonDatabaseConfiguration databasePassword: value]; 
		readonly: true; 
		with: self getOrbeonDatabaseConfiguration databasePassword.
	html label with: 'Orbeon IP'.
	html textInput 
		callback: [:value | self getOrbeonWebServerConfiguration orbeonIP: value]; 
		readonly: true; 
		with: self getOrbeonWebServerConfiguration orbeonIP.
	html label with: 'GemStone/S IP'.
	html textInput 
		callback: [:value | self getGemStoneServerConfiguration gemstoneIP: value]; 
		readonly: true; 
		with: self getGemStoneServerConfiguration gemstoneIP.! !

!FormServerConfigurationComposite methodsFor: 'other' stamp: 'BrunoBB 03/16/2015 05:53'!
savePreferences! !

SEWAFWebObjectComposite subclass: #FormUserPasswordComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!FormUserPasswordComposite methodsFor: 'other' stamp: 'BrunoBB 06/24/2015 13:45'!
changePassword

	(self session user password = (searchValues at: 'current-pwd')) ifFalse: [^self inform: ('Invalid Current Password' translateFor: self session user)].

	((searchValues at: 'repeat-new-pwd') = (searchValues at: 'new-pwd')) ifFalse: [^self inform: ('New Password and Repeat New Password must be equal' translateFor: self session user)].

	self session user password: (searchValues at: 'new-pwd').! !

!FormUserPasswordComposite methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 10:41'!
renderChangePasswordOn: html

	html div id: 'change-password'; class: 'centered-unique-form';
		with: [html form with: [
					html fieldSet with:[
						html legend with: [html strong: ('Change Password' translateFor: self session user)].
						html label attributeAt: 'for' put: 'currentPassword'; with: ('Current Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'currentPassword'; callback: [:value | searchValues at: 'current-pwd' put: value].
						html label attributeAt: 'for' put: 'newPassword'; with: ('New Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'newPassword'; callback: [:value | searchValues at: 'new-pwd' put: value].
						html label attributeAt: 'for' put: 'newPassword2'; with: ('Repeat New Password' translateFor: self session user).
						html textInput attributeAt: 'id' put: 'newPassword2'; callback: [:value | searchValues at: 'repeat-new-pwd' put: value].
						html submitButton callback: [self changePassword]; with: ('Confirm' translateFor: self session user).
					].
				].
		].! !

!FormUserPasswordComposite methodsFor: 'other' stamp: 'BrunoBB 03/17/2015 16:25'!
renderContentOn: html

	self renderChangePasswordOn: html.! !

SEWAFWebObjectComposite subclass: #OrbeonFormsUpdateComposite
	instanceVariableNames: 'selectedApplications selectedDefinitions batchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!OrbeonFormsUpdateComposite methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 14:03'!
importNewApplications

	^#deprecated.
"
	^OrbeonHandler default importNewApplicationsButNoData
"! !

!OrbeonFormsUpdateComposite methodsFor: 'other' stamp: 'BrunoBB 03/09/2016 03:26'!
initialize

	super initialize.

	selectedApplications := #().
	selectedDefinitions := #().

	batchedList := SewafBatchedList parentComponent: self.

	batchedList batchSize: 5;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.! !

!OrbeonFormsUpdateComposite methodsFor: 'other' stamp: 'BrunoBB 02/26/2016 13:42'!
renderApplicationsListOn: html
	| apps |

	apps := self session user getOrbeonBackofficeApplications.
	html multiSelect 
		attributeAt: 'title' put: ('Orbeon Applications' translateFor: self session user);
		list: (apps collect: [:each | each applicationName]) asSortedCollection;
		size: apps size;
		callback: [:value | self selections: value].! !

!OrbeonFormsUpdateComposite methodsFor: 'other' stamp: 'BrunoBB 03/04/2016 14:16'!
renderContentOn: html

	html div id: 'orbeon-list-application'; class: 'centered-unique-form';
		with: [
			html form with: [
				html fieldSet with:[ 
					html legend with: [html strong: ('Manage Current Orbeon Forms' translateFor: self session user)].
					html div id: 'applications-list'; with: [self renderApplicationsListOn: html].
					html div id: 'forms-operations'; with: [self renderFormOperationsOn: html]].
			]
	].

	html div id: 'orbeon-definitions-list'; class: 'default-gray-table ';
		with: [self renderFormDefinitionsOn: html].! !

!OrbeonFormsUpdateComposite methodsFor: 'other' stamp: 'BrunoBB 03/09/2016 03:25'!
renderFormDefinitionsOn: html

	selectedDefinitions ifNil: [^self].

	html render: (batchedList table: self sewafTableForOrbeonFormDefinitions).! !

!OrbeonFormsUpdateComposite methodsFor: 'other' stamp: 'BrunoBB 02/29/2016 10:35'!
renderFormOperationsOn: html

	html submitButton callback: [self showFormDefinitions]; with: ('Show Form Definitions' translateFor: self session user).

"These two operation are deprecated since there a Orbeon Persistence Layer now and synchronization is 100% with Orbeon "

"	html submitButton callback: [self importNewApplications]; with: ('Import New Applications' translateFor: self session user).
	html submitButton callback: [self updateSelectedApplications]; with: ('Update Selected Applications' translateFor: self session user)."! !

!OrbeonFormsUpdateComposite methodsFor: 'other' stamp: 'BrunoBB 11/02/2014 11:16'!
selections: value

	selectedApplications := value! !

!OrbeonFormsUpdateComposite methodsFor: 'other' stamp: 'BrunoBB 11/09/2014 12:26'!
sewafTableForOrbeonFormDefinitions

	^(SewafTableReport summary: 'Orbeon Form Definitions')
		rows: selectedDefinitions; "get collection elements"
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #app title: 'Application');
						add: (SewafReportColumn selector: #form title: 'Form');
						add: (SewafReportColumn selector: #version title: 'Version');
						add: (SewafReportColumn selector: #createdTime title: 'Created');
						add: (SewafReportColumn selector: #modifiedTime title: 'Modified');
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

!OrbeonFormsUpdateComposite methodsFor: 'other' stamp: 'BrunoBB 03/09/2016 03:23'!
showFormDefinitions

	selectedDefinitions := OrderedCollection new.
	selectedApplications do: [:eachApp | | app |
		app := self getOrbeonApplicationClass applicationNamed: eachApp.
		selectedDefinitions addAll: app getLastDefinitions.
		].

	batchedList items: selectedDefinitions.! !

!OrbeonFormsUpdateComposite methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 14:03'!
updateSelectedApplications
	| appToUpdate |

	^#deprecated.
"
	appToUpdate := ((selectedApplications collect: [:each | self getApplicationManagerClass applicationNamed: each ifNone: [nil]])
							select: [:each | each notNil]).

	appToUpdate do: [:eachApp | OrbeonHandler default updateApplicationButNotDataOf: eachApp].

	^self
"! !

SEWAFWebObjectComposite subclass: #WAInternationalizationManager
	instanceVariableNames: 'stringKey translatedString newLanguageName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAInternationalizationManager methodsFor: 'other' stamp: 'BrunoBB 06/23/2015 14:13'!
currentDictionaryName

	^searchValues at: 'selected-language' ifAbsent: ['']! !

!WAInternationalizationManager methodsFor: 'Accessing' stamp: 'BrunoBB 06/23/2015 14:19'!
newLanguageName
	^newLanguageName! !

!WAInternationalizationManager methodsFor: 'Updating' stamp: 'BrunoBB 06/23/2015 14:19'!
newLanguageName: newValue
	newLanguageName := newValue! !

!WAInternationalizationManager methodsFor: 'other' stamp: 'BrunoBB 03/11/2016 12:02'!
renderAddNewTranslationOn: html

	html form with: [
		html fieldSet with:[
			html legend with: [html strong: ('Add Translation' translateFor: self session user)].
				html label attributeAt: 'for' put: 'txtToTranslate'; with: ('Text to Translate' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'txtToTranslate'; callback: [:value | stringKey := value]; with: stringKey.
				html label attributeAt: 'for' put: 'translation'; with: ('Translation' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'translation'; callback: [:value | translatedString := value]; with: translatedString.
				html submitButton callback: [self saveTranslation]; with: ('Save Translation' translateFor: self session user).
					].
				].
	html horizontalRule.! !

!WAInternationalizationManager methodsFor: 'other' stamp: 'BrunoBB 03/11/2016 12:02'!
renderContentOn: html

	html div id: 'internationalization'; with: [
		html form with: [ 
			html fieldSet with: [
			html legend with: [html strong: ('Languages' translateFor: self session user)].
					html label attributeAt: 'for' put: 'language'; with: ('Languages' translateFor: self session user).
					html select attributeAt: 'id' put: 'language'; class: '';
						list: (#(''), self getInternationalization currentDictionaries);
						onChange: 'submit()';
						callback: [:value | searchValues at: 'selected-language' put: value];
						selected: self currentDictionaryName.
					html label attributeAt: 'for' put: 'newLanguage'; with: ('New Language' translateFor: self session user).
					html textInput attributeAt: 'id' put: 'newLanguage'; callback: [:value | newLanguageName := value]; with: newLanguageName.
					html submitButton 
						callback: [self saveLanguage]; 
						with: ('Save Language' translateFor: self session user).
				].
			].
		html horizontalRule.
		self renderCurrentDictionaryTranslationsOn: html.].! !

!WAInternationalizationManager methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:49'!
renderCurrentDictionaryTranslationsOn: html
	| currentDictionary |

	searchValues at: 'selected-language' ifAbsent: [^self].

	self renderAddNewTranslationOn: html.

	currentDictionary := self getInternationalization getTranslationsOf: (searchValues at: 'selected-language').

	html div id: 'inter-current-dictionary'; with: [
		currentDictionary keys asSortedCollection do: [:key | 
			html output: key, ' | '.
			html span: (currentDictionary at: key).
			html break.
		].
	].! !

!WAInternationalizationManager methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:49'!
saveLanguage

	self getInternationalization addLanguage: newLanguageName trimBlanks asSymbol! !

!WAInternationalizationManager methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:49'!
saveTranslation

	self getInternationalization
		translate: stringKey 
		as: translatedString 
		for: self currentDictionaryName! !

!WAInternationalizationManager methodsFor: 'Accessing' stamp: 'BrunoBB 06/23/2015 14:12'!
stringKey
	^stringKey! !

!WAInternationalizationManager methodsFor: 'Updating' stamp: 'BrunoBB 06/23/2015 14:12'!
stringKey: newValue
	stringKey := newValue! !

!WAInternationalizationManager methodsFor: 'Accessing' stamp: 'BrunoBB 06/23/2015 14:12'!
translatedString
	^translatedString! !

!WAInternationalizationManager methodsFor: 'Updating' stamp: 'BrunoBB 06/23/2015 14:12'!
translatedString: newValue
	translatedString := newValue! !

SEWAFWebObjectComposite subclass: #WAManageFormProcessCategory
	instanceVariableNames: 'selectedCategory batchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAManageFormProcessCategory methodsFor: 'Accessing' stamp: 'BrunoBB 03/08/2016 16:25'!
batchedList
	^batchedList! !

!WAManageFormProcessCategory methodsFor: 'Updating' stamp: 'BrunoBB 03/08/2016 16:25'!
batchedList: newValue
	batchedList := newValue! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 16:34'!
categoryColorColumn

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html colorInput 
					attributeAt: 'title' put: ('Color' translateFor: self session user);
					disabled;
					value: each color.] 
			title: ('Color' translateFor: self session user)) sortBlock: nil; 
			yourself! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/10/2016 06:19'!
createNewCategory

	model addToCacheIn: self session user username.

	batchedList add: model.

	model := BpmProcessDefinitionCategory new.! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 12/15/2015 10:17'!
getAllUserCategories

	^BpmProcessDefinitionCategory getCategoriesFor: self session user! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/04/2016 13:48'!
gitbookUrl

	^'https://brunobuzzi.gitbooks.io/bpm-using-orbeon-and-gemstone-s/content/bpm_backoffcie.html'! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 16:27'!
initialize

	super initialize.

	model := BpmProcessDefinitionCategory new.

	batchedList := SewafBatchedList parentComponent: self items: self getAllUserCategories.

	batchedList batchSize: 10;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 12/14/2015 11:57'!
modifyCategory

	selectedCategory removeFromCacheFrom: self session user username.

	selectedCategory name: (self componentValueAt: 'name').
	selectedCategory color: (self componentValueAt: 'color').

	selectedCategory addToCacheIn: self session user username.! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/09/2016 11:24'!
removeCategory

	selectedCategory removeFromCacheFrom: self session user username.

	batchedList remove: selectedCategory.

	selectedCategory := nil.

	model := BpmProcessDefinitionCategory new.! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/04/2016 06:40'!
renderCategoryFormOn: html

	html div class: 'centered-unique-form float-left'; with: [
		html form 
			"class: 'height250';"
			with: [
				html fieldSet with: [
					selectedCategory 
						ifNil: [self renderNewCategoryOn: html]
						ifNotNil: [self renderSelectedCategoryOn: html].
			].
		]
	].! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 16:27'!
renderContentOn: html

	html div with: [

		self renderCategoryFormOn: html.

		html div class: 'default-gray-table float-left';
			with:[html render: (batchedList table: self sewafTableForUserCategories).].
	].! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 14:55'!
renderNewCategoryOn: html

	html legend with: [html strong: ('New Category' translateFor: self session user)].
	html label 
		attributeAt: 'for' put: 'name'; 
		with: ('Name' translateFor: self session user).
	html textInput 
		attributeAt: 'id' put: 'name'; 
		callback: [:value | model name: value].
	html label 
		attributeAt: 'for' put: 'color'; 
		with: ('Color' translateFor: self session user).
	html colorInput 
		attributeAt: 'id' put: 'color'; 
		callback: [:value | model color: value].
	html submitButton 
		class: 'display-block margin-top-15px';
		callback: [self createNewCategory]; 
		with: ('Create Category' translateFor: self session user)! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 15:05'!
renderSelectedCategoryOn: html

	html legend with: [html strong: ('Selected Category' translateFor: self session user)].
	html label 
		attributeAt: 'for' put: 'name'; 
		with: ('Name' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'name';
		value: selectedCategory name;
		callback: [:value | self addValue: value named: 'name'].
	html label 
		attributeAt: 'for' put: 'color'; 
		with: ('Color' translateFor: self session user).
	html colorInput attributeAt: 'id' put: 'color';
		value: selectedCategory color; 
		callback: [:value | self addValue: value named: 'color'].
	html submitButton 
		class: 'display-block margin-top-15px';
		callback: [self modifyCategory]; 
		with: ('Modify Category' translateFor: self session user).
	html submitButton 
		class: 'display-block margin-top-15px';
		callback: [self removeCategory]; 
		with: ('Remove Category' translateFor: self session user).! !

!WAManageFormProcessCategory methodsFor: 'Accessing' stamp: 'BrunoBB 10/07/2014 06:12'!
selectedCategory

   "Return the value of the instance variable 'selectedCategory'."
   ^selectedCategory! !

!WAManageFormProcessCategory methodsFor: 'Updating' stamp: 'BrunoBB 10/07/2014 06:12'!
selectedCategory: newValue

   "Modify the value of the instance variable 'selectedCategory'."
   selectedCategory := newValue! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 07/23/2015 13:04'!
sewafTableForUserCategories

	^(SewafSelectTableReport summary: 'User Process Definition Categories')
		rows: self getAllUserCategories; "get collection elements"
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #name title: ('Category Name' translateFor: self session user) onClick: 
						[:each | (selectedCategory == each) ifTrue: [selectedCategory := nil] ifFalse: [selectedCategory := each]]);
						add: self categoryColorColumn;
						yourself);
		selectedObject: selectedCategory;
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

SEWAFWebObjectComposite subclass: #WAOrbeonRadarComposite2
	instanceVariableNames: 'searchCollectionResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAOrbeonRadarComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:53'!
getFreeTransitions

	selectedObject ifNil: [^#()].

	^selectedObject getAllAvailableTaskAssignments! !

!WAOrbeonRadarComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:55'!
getProcessWithFreeTransitions

	^selectedObject getAllAvailableTaskAssignments! !

!WAOrbeonRadarComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:53'!
initialize

	super initialize.

	searchCollectionResult := OrderedCollection new.! !

!WAOrbeonRadarComposite2 methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 14:53'!
searchCollectionResult
	^searchCollectionResult! !

!WAOrbeonRadarComposite2 methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2015 14:53'!
searchCollectionResult: newValue
	searchCollectionResult := newValue! !

WAOrbeonRadarComposite2 subclass: #WAOrbeonRadarProcessComposite2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
createFilledFormsColumn

	^(SewafReportColumn selector: #printFormNames title: ('Filled Forms' translateFor: self session user))
		cssClass: 'max-width-td';
		yourself! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
getFormDefinitions

	^#(''), (self selectedApplication getLastDefinitions collect: [:each | each form]) asArray! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
getFormFields
	| def |

	self hasFormDefinition ifFalse: [^OrderedCollection new].
	def := self selectedFormDefinition.
	^def ifNil: [OrderedCollection new] ifNotNil: [def getFieldsNames asSortedCollection]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 15:58'!
getSelectedApplication

	^self searchValueAt: 'application'! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 15:57'!
getSelectedFormDefinition

	^self searchValueAt: 'form-definition'! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 15:58'!
getSelectedFormField

	^self searchValueAt: 'form-field'! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 15:58'!
getSelectedFormFieldValue

	^self searchValueAt: 'field-value'! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 15:58'!
getSelectedFormFieldValue2

	^self searchValueAt: 'field-value-2'! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
hasFormDefinition

	^(searchValues includesKey: 'form-definition') and: [(searchValues at: 'form-definition') notEmpty]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
hasFormField

	^(searchValues includesKey: 'form-field') and: [(searchValues at: 'form-field') notEmpty]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
hasProcessId

	^(searchValues includesKey: 'id') and: [(searchValues at: 'id') notEmpty]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
hasSelectedApplication

	^(searchValues includesKey: 'application') and: [(searchValues at: 'application') notEmpty]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
initialize

	super initialize.

	searchCollectionResult := OrderedCollection new.! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
onApplicationChanged: appName

	searchValues 
		removeKey: 'form-definition' ifAbsent: [];
		removeKey: 'form-field' ifAbsent: [];
		at: 'application' put: appName.! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
onCheckboxFinishedChanged: aBoolean

	searchValues at: 'filter-finished' put: aBoolean! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
onFormDefinitionChanged: definitionName

	searchValues at: 'form-definition' put: definitionName! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
onFormFieldChanged: fieldName

	searchValues at: 'form-field'  put: fieldName.! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
onProcessIdChanged: value

	searchValues at: 'id' put: value! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 03/04/2016 12:10'!
renderApplicationComboOn: html

	html label attributeAt: 'for' put: 'application'; with: ('Application' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'application'; 
		list: (#(''), (self session user getBackofficeApplications collect: [:each | each applicationName]) asSortedCollection);
		onChange: 'submit()';
		selected: (searchValues at: 'application' ifAbsent: ['']);
		callback: [:value | searchValues at: 'application' put: value].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 03/04/2016 12:12'!
renderContentOn: html

	html div id: 'top-search-area'; with: [self renderSearchOptionsOn: html].

	html div id: 'process-instances'; class: 'default-gray-table ';
		with:[html render: self sewafTableForRunningFormProcesses.].

	searchCollectionResult isEmpty ifTrue: [^self].
	selectedObject ifNil: [^self].

	html div id: 'process-assignments'; class: 'default-gray-table ';
		with:[html render: self sewafTableForProcessAssignments.].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:33'!
renderFilterValuesAndButtonOn: html
	| app formDef fieldType |

	app := self getApplicationManagerClass getAnyApplicationNamed: (searchValues at: 'application').
	formDef := app definitionNamed: (searchValues at: 'form-definition').
	formDef ifNil: [^self].
	fieldType := formDef typeOf: (searchValues at: 'form-field').

	(#('xf:boolean' 'xf:string' ) includes: fieldType) ifTrue: [^self renderOneFilterOn: html].

	^self renderTwoFitersOn: html! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
renderFormDefinitionComboOn: html

	html label attributeAt: 'for' put: 'formDefinitions';
		with: ('Form Definition' translateFor: self session user).

	html select attributeAt: 'id' put: 'formDefinitions'; "Process Definition List"
		list: self getFormDefinitions;
		onChange: 'submit()';
		callback: [:value | self onFormDefinitionChanged: value];
		selected: (searchValues at: 'form-definition' ifAbsent: [' ']).

	html break.

	self renderFormFieldsComboOn: html. "render fields of the selected form definition"! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
renderFormFieldsComboOn: html
	| app formDef fieldType |

	html label 
		attributeAt: 'for' put: 'formFields'; 
		class: 'search-section-float-left'; with: ('Form Fields' translateFor: self session user).
	html select attributeAt: 'id' put: 'formFields';
		class: 'search-section-float-left';"Process Definition List"
		list: (#(''), self getFormFields) asSortedCollection;
		onChange: 'submit()';
		callback: [:value | self onFormFieldChanged: value];
		selected: (searchValues at: 'form-field' ifAbsent: ['']).

	self hasFormField
	ifTrue: [self renderFilterValuesAndButtonOn: html]
	ifFalse: [self renderSubmitButtonOn: html]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
renderOneFilterOn: html

	html submitButton 
		class: 'search-section-float search-section-width-100';
		callback: [self searchMatchingProcesses]; 
		with: ('Search' translateFor: self session user).

	html label attributeAt: 'for' put: 'filterOne';
		class: 'search-section-float'; with: ('Field Value' translateFor: self session user).

	html textInput attributeAt: 'id' put: 'filterOne';
		class: 'search-section-float search-section-width-200';
		callback: [:value | searchValues at: 'field-value' put: value].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
renderSearchOptionsOn: html

	html form with: [ 
		html fieldSet with: [
			html legend with: ('Search Options' translateFor: self session user).
			html label attributeAt: 'for' put: 'id'; with: ('Id' translateFor: self session user).
			html textInput attributeAt: 'id' put: 'id';
				callback: [:value | self onProcessIdChanged: value];
				with: (searchValues at: 'id' ifAbsent: ['']).
			html label: [ 
				html checkbox
					value: (searchValues at: 'filter-finished' ifAbsent: [false]);
					callback: [ :value | self onCheckboxFinishedChanged: value ].
				html text: ('Filter Finished' translateFor: self session user).].
			self renderApplicationComboOn: html.
			self hasSelectedApplication 
			ifTrue: [self renderFormDefinitionComboOn: html.]
			ifFalse: [self renderSubmitButtonOn: html].
		].
	].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
renderSubmitButtonOn: html

	html submitButton class: 'search-section-float search-section-width-100';
						callback: [self searchProcessId]; with: ('Search' translateFor: self session user).! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
renderTwoFitersOn: html

	html submitButton class: 'search-section-float search-section-width-100';
						callback: [self searchMatchingProcessesRange]; with: ('Search' translateFor: self session user).

	html label attributeAt: 'for' put: 'filterOne';
		class: 'search-section-float'; with: ('End' translateFor: self session user).

	html textInput attributeAt: 'id' put: 'filterOne';
		class: 'search-section-float search-section-width-200';
		callback: [:value | searchValues at: 'field-value-2' put: value].

	html label attributeAt: 'for' put: 'filterTwo';
		class: 'search-section-float'; with: ('Start' translateFor: self session user).

	html textInput attributeAt: 'id' put: 'filterTwo';
		class: 'search-section-float search-section-width-200';
		callback: [:value | searchValues at: 'field-value' put: value].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'searching' stamp: 'BrunoBB 02/25/2016 12:38'!
searchByApplication
	| app |

	selectedObject := nil.
	self hasSelectedApplication ifFalse: [^self].
	self hasFormDefinition ifTrue: [^self searchByApplicationAndFormDefinition].

	app := self searchValueAt: 'application'.

	app notNil 
	ifTrue: [searchCollectionResult := BpmRunningTasksMatrix getAllAvailableTaskAssignmentsIn: (OrderedCollection with: (self getApplicationManagerClass getAnyApplicationNamed: app ifNone: [#()])).].

	searchValues 
		removeKey: 'form-definition' ifAbsent: [];
		removeKey: 'form-field' ifAbsent: [].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'searching' stamp: 'BrunoBB 02/25/2016 12:38'!
searchByApplicationAndFormDefinition
	| application |
	 "searchCollectionResult := OrbeonFormProcessDefinition getProcessInstancesOf: self getSelectedApplication ofFormNamed: self getSelectedFormDefinition."

	application := self getApplicationManagerClass getAnyApplicationNamed: (self searchValueAt: 'application') ifNone: [nil].
	application ifNil: [^searchCollectionResult := #()].

	searchCollectionResult := BpmRunningTasksMatrix getAllAvailableTaskAssignmentsIn: (OrderedCollection with: application).

	searchCollectionResult := searchCollectionResult select: [:each | each process hasTaskNamed: self getSelectedFormDefinition]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 02/07/2016 15:15'!
searchMatchingProcesses
	| processes |

	selectedObject := nil.
	self hasProcessId ifTrue: [^self searchProcessId].

	(self hasSelectedApplication and:[self hasFormDefinition not]) 
	ifTrue: [^self searchByApplication].

	(self hasSelectedApplication and:[self hasFormDefinition and:[self hasFormField not]])
	ifTrue: [^self searchByApplicationAndFormDefinition].

	processes := BpmProcessDefinition getProcessInstancesOf: self getSelectedApplication ofFormNamed: self getSelectedFormDefinition.

	searchCollectionResult := processes select: [:each | 
		each hasFormDefinitionNamed: self getSelectedFormDefinition 
				withFieldName: self getSelectedFormField 
				withValue: self getSelectedFormFieldValue].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 02/07/2016 15:16'!
searchMatchingProcessesRange
	| processes |

	selectedObject := nil.
	self hasProcessId ifTrue: [^self searchProcessId].

	(self hasSelectedApplication and:[self hasFormDefinition not]) 
	ifTrue: [^self searchByApplication].

	(self hasSelectedApplication and:[self hasFormDefinition and:[self hasFormField not]])
	ifTrue: [^self searchByApplicationAndFormDefinition].

	processes := BpmProcessDefinition getProcessInstancesOf: self getSelectedApplication ofFormNamed: self getSelectedFormDefinition.

	searchCollectionResult := processes select: [:each | 
		each hasFormDefinitionNamed: self getSelectedFormDefinition 
				withFieldName: self getSelectedFormField 
				initValue: self getSelectedFormFieldValue 
				endValue: self getSelectedFormFieldValue2].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'searching' stamp: 'BrunoBB 12/21/2015 10:05'!
searchProcessId
	| tasks id |

	selectedObject := nil.
	self hasProcessId ifFalse: [^self hasSelectedApplication ifTrue:[self searchByApplication] ifFalse:[self]].

	id := [Integer fromString: (searchValues at: 'id')] on: Error do: [:err | 0].

	tasks := BpmRunningTasksMatrix getAllAvailableTaskAssignments.

	searchCollectionResult := tasks select: [:each | each processId = id].

	searchValues 
		removeKey: 'form-definition' ifAbsent: [];
		removeKey: 'form-field' ifAbsent: [];
		removeKey: 'application' ifAbsent: [].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:38'!
selectedApplication

	^self getApplicationManagerClass 
			getAnyApplicationNamed: (searchValues at: 'application') 
			ifNone: [self getOrbeonApplicationClass new]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
selectedFormDefinition

	^self selectedApplication definitionNamed: (searchValues at: 'form-definition')! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
sewafTableForProcessAssignments

	^(SewafSelectTableReport parent: self)
		summary: 'Process Assignments';
		rows: selectedObject assignments; "get collection elements"
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #creationDate title: 'Creation Date');
						add: (SewafReportColumn selector: #assignmentDate title: 'Assigned Date');
						add: (SewafReportColumn selector: #creatorName title: 'Created By');
						add: self createFilledFormsColumn;
						yourself);
		rowColors: #(white white);
		selectedObject: selectedObject;
		rowPeriod: 1;
		yourself! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 15:40'!
sewafTableForRunningFormProcesses

	^(SewafSelectTableReport parent: self)
		summary: 'Radar for Processes';
		rows: searchCollectionResult; "get collection elements"
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #applicationName title: 'Application' onClick: [:each | selectedObject := each]);
						add: (SewafReportColumn selector: #processName title: 'Name');
						add: (SewafReportColumn selector: #processId title: 'Process Id');
						add: (SewafReportColumn selector: #printRunningArtifacts title: 'Current Tasks');
						add: (SewafReportColumn selector: #hasFinalized title: 'Finished');
						add: (SewafReportColumn selector: #creatorName title: 'Creator');
						add: (SewafReportColumn selector: #creationDate title: 'Creation Time');
						add: (SewafReportColumn selector: #printCurrentRols title: 'Roles');
						yourself);
		rowColors: #(white white);
		selectedObject: selectedObject;
		rowPeriod: 1;
		yourself! !

WAOrbeonRadarComposite2 subclass: #WAOrbeonRadarUserComposite2
	instanceVariableNames: 'listType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 12/20/2015 14:54'!
assignUserTo: aBpmProcessInstance value: aBoolean
	"Create a new OrbeonFormProcess based on the definition OrbeonFormProcessDefinition <selectedDefinition> for the user <anOrbeonFormUser>.
	1- Create an OrbeonProcessAssignment.
	2- Add the new assignment of 1) to process <anOrbeonFormProcess>.
	3- Associate the Assignment with the Process.
	4- The user <anOrbeonFormUser> take the assignment <anOrbeonProcessAssignment>"

	aBoolean ifFalse: [^self].
	"another user could be take the process already"
	(self checkIfProcessStillAvailable: aBpmProcessInstance) 
	ifFalse: [^self inform: 'Process [', 
									aBpmProcessInstance processId printString, '] [', 
									aBpmProcessInstance name, '] [',
									aBpmProcessInstance printRunningArtifacts,'] - Has been already Taken by other user !!!!!!']. 

	"^OrbeonProcessAssignment associateWithProcess: aBpmProcessInstance for: selectedObject"! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 12/20/2015 14:54'!
buttonLabel

	(listType = 'Possible Tasks') ifTrue: [^'Take Task'].

	^'Untake Task'! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 12/20/2015 14:54'!
checkIfProcessStillAvailable: anOrbeonFormProcess
	"Check if another user has taken the process already"

	^anOrbeonFormProcess checkIfStillAvailableFor: selectedObject! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
elements
	^ #( 'Current Tasks' 'Possible Tasks')! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
getProcessWithFreeTransitions

	^selectedObject getAllAvailableTaskAssignments! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 12/20/2015 14:54'!
getSelectedUserAssignments

	^selectedObject currentAssignments! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 12/20/2015 14:54'!
getTransitionList

	(listType = 'Possible Tasks') ifTrue: [^self getProcessWithFreeTransitions].

	^self getSelectedUserAssignments! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
initialize

	super initialize.

	listType := 'Current Tasks'.! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
isAssignedToProcess: anOrbeonFormUser

	^false! !

!WAOrbeonRadarUserComposite2 methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 14:54'!
listType

   "Return the value of the instance variable 'listType'."
   ^listType! !

!WAOrbeonRadarUserComposite2 methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2015 14:54'!
listType: newValue

   "Modify the value of the instance variable 'listType'."
   listType := newValue! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
onUsernameChanged: value

	searchValues at: 'username' put: value! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 03/04/2016 11:35'!
renderContentOn: html

	html div id: 'top-search-area'; with: [self renderSearchOptionsOn: html].

	html div id: 'radar'; with: [
		html div id: 'radar-users'; class: 'default-gray-table ';
				with:[html render: self sewafTableForUsers.].

		selectedObject ifNil: [^self].

		html div id: 'radar-processes-list'; class: 'default-gray-table ';
			with:[html render: self sewafTableForRunningFormProcesses.]
	].! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
renderOptionListOn: html

	html radioGroup
		callback: [:value | listType := value];
		selected: listType;
		with: [ :group |
			self elements do: [ :each |
				html label: [ 
					group radioButton onChange: 'submit()'; value: each.
					html text: each ].] ].! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
renderSearchOptionsOn: html

	html form with: [ 
		html fieldSet with: [
			html legend with: ('Search Options' translateFor: self session user).
			html label attributeAt: 'for' put: 'username'; with: ('Username' translateFor: self session user).
			html textInput attributeAt: 'id' put: 'username';
				callback: [:value | self onUsernameChanged: value]; 
				with: (searchValues at: 'username' ifAbsent: ['']).
			self renderOptionListOn: html.
			self renderSubmitButtonOn: html.
		].
	].! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
renderSubmitButtonOn: html

	html submitButton class: 'search-section-float search-section-width-100';
						callback: [self searchUsername]; with: ('Search' translateFor: self session user).! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
searchUsername
	| username |

	selectedObject := nil.
	searchCollectionResult := OrderedCollection new.

	username := searchValues at: 'username' ifAbsent: ''.

	searchCollectionResult := self session user getVisibleUsers select: [:each | each username = username].! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
setRadioButton! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 12/20/2015 14:54'!
sewafTableForRunningFormProcesses

	^(SewafBooleanSelectTable parent: self)
		summary: 'Free Processes';
		buttonTitle: 'Confirm Selection';
		buttonLabel: self buttonLabel;
		rows: self getTransitionList; "get collection elements"
		booleanSelector: #isAssignedToProcess:;
		callbackSelector: #assignUserTo:value:;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #processId title: 'Process Id' onClick: [:each |]);
						add: (SewafReportColumn selector: #processName title: 'Process Name');
						add: (SewafReportColumn selector: #printRunningArtifacts title: 'Current Tasks');
						add: (SewafReportColumn selector: #printCurrentRols title: 'Roles');
						add: (SewafReportColumn selector: #creatorName title: 'Creator');
						add: (SewafReportColumn selector: #assignedUserNames title: 'Assigned Users');
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
sewafTableForUsers
	"Table with all Users that are NOT present in the role <selectedObject> "

	^(SewafSelectTableReport parent: self)
		summary: 'Users to Assign';
		rows: searchCollectionResult; "get collection elements"
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #username title: 'Username' onClick: [:each | selectedObject := each]);
						add: (SewafReportColumn selector: #isAdmin title: 'Admin?');
						yourself);
		rowColors: #(white white);
		selectedObject: selectedObject;
		rowPeriod: 1;
		yourself! !

SEWAFWebObjectComposite subclass: #WAXpdlImporterBrowser
	instanceVariableNames: 'orbeonApplications orbeonApplication upload processNode reader numberOfProcess uploadProcesses selectedUploads processesNames fileFormats invalidFormatError packageFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/09/2015 10:23'!
addNewProcessForm

	numberOfProcess := numberOfProcess + 1.! !

!WAXpdlImporterBrowser methodsFor: 'import' stamp: 'BrunoBB 12/09/2015 10:23'!
checkFilesFormatOf: pathFileArray

	pathFileArray do: [:eachPathFile | | file contents |
		file := FileStream fileNamed: eachPathFile.
		contents := file contents.
		file close.
		[XMLDOMParser parse: contents] 
			on: Error 
			do: [:err | fileFormats at: (eachPathFile subStrings: '/') last put: err description.]].

	^fileFormats isEmpty! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 11:50'!
fileFormats
	^fileFormats! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 11:50'!
fileFormats: newValue
	fileFormats := newValue! !

!WAXpdlImporterBrowser methodsFor: 'import' stamp: 'BrunoBB 02/25/2016 12:33'!
generateMapperDictionary
	| dictionary |

	dictionary := Dictionary new.

	selectedUploads keysAndValuesDo: [:index :processName |
		(processName size > 5)
		ifTrue: [dictionary at: (processName allButLast: 5) put: (self getApplicationManagerClass getAnyApplicationNamed: (uploadProcesses at: index))].
	].

	^dictionary! !

!WAXpdlImporterBrowser methodsFor: 'import' stamp: 'BrunoBB 02/25/2016 12:33'!
getApplicationFor: xpdlPackage
	| appName |

	appName := (uploadProcesses at: (selectedUploads keyAtValue: (xpdlPackage getName, '.xpdl') ifAbsent: [Error signal])).

	^self getApplicationManagerClass getAnyApplicationNamed: appName! !

!WAXpdlImporterBrowser methodsFor: 'import' stamp: 'BrunoBB 01/22/2016 11:07'!
importBizagiFiles
	| appDictionary fileArray generator |

	appDictionary := Dictionary new.
	fileArray := OrderedCollection new.

	1 to: numberOfProcess do: [:index | | fileName shortName |
		fileName := selectedUploads at: index.
		shortName := fileName allButLast: (FileDirectory extensionFor: fileName) size + 1.
		appDictionary at: shortName put: (uploadProcesses at: index).
		fileArray add: ((FileDirectory default directoryNamed: 'tmp') pathName, '/', fileName)].

	(self checkFilesFormatOf: fileArray) ifFalse: [^self].
	"ERROR handler"
	reader := XPDLReader2 forFiles: fileArray asArray.

	generator := BpmProcessGenerator on: reader xpdlPackages.

	generator xpdlPackages do: [:eachPackage | 
		eachPackage pools do: [:eachPool | 
			generator mapProcess: eachPool getName toApplication: (self getApplicationFor: eachPackage).
		].
	].

	reader getImportWarningReportWith: self generateMapperDictionary.

	"If false --> the processes definition are created and stored"
	reader hasWarnings ifFalse: [^generator generateAllProcess do: [:each | each addToCache]].

	self show: ((WABizagiImportReport parent: self)
						warnings: reader importReport;
						yourself).! !

!WAXpdlImporterBrowser methodsFor: 'other' stamp: 'BrunoBB 01/21/2016 11:50'!
initialize

	super initialize.

	numberOfProcess := 1.
	uploadProcesses := Dictionary new.
	selectedUploads := Dictionary new.
	processesNames := Dictionary new.
	fileFormats := Dictionary new. "to check if files are well formated"! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 11:50'!
invalidFormatError
	^invalidFormatError! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 11:50'!
invalidFormatError: newValue
	invalidFormatError := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
numberOfProcess
	^numberOfProcess! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
numberOfProcess: newValue
	numberOfProcess := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
orbeonApplication
	^orbeonApplication! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
orbeonApplication: newValue
	orbeonApplication := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
orbeonApplications
	^orbeonApplications! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
orbeonApplications: newValue
	orbeonApplications := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 11:50'!
packageFile
	^packageFile! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 11:50'!
packageFile: newValue
	packageFile := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
processesNames
	^processesNames! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
processesNames: newValue
	processesNames := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
processNode
	^processNode! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
processNode: newValue
	processNode := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
reader
	^reader! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
reader: newValue
	reader := newValue! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/09/2015 11:46'!
receiveFile: aFile index: index
	"The receiver store the file <aFile> temporary directory -temp- and add the file name of <aFile> at collection <selectedUploads> index <index>"
    | stream |

    stream := (FileDirectory default directoryNamed: 'tmp') "create the temporary file"
        assureExistence;
        forceNewFileNamed: aFile fileName.
    [ stream binary; nextPutAll: aFile rawContents ]  "push contents"
        ensure: [ stream close ].

	selectedUploads at: index put: aFile fileName. "map index with fileName"! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 01/21/2016 11:52'!
removeImportProcessForm

	uploadProcesses removeKey: numberOfProcess ifAbsent: [].
	selectedUploads removeKey: numberOfProcess ifAbsent: [].
	processesNames removeKey: numberOfProcess ifAbsent: [].

	numberOfProcess := numberOfProcess  - 1! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/09/2015 10:23'!
renderAddNewImportFormButtonOn: html

	html anchor callback: [self addNewProcessForm];
					with: [html image url: (SEWAFIconLibrary / #textplusiconPng); 
								altText: ('Add New Import Process Form' translateFor: self session user); 
								title: ('Add New Import Process Form' translateFor: self session user)].! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/09/2015 10:23'!
renderContentOn: html

	html div id: 'import-forms'; with: [
		1 to: numberOfProcess do: [:index |
			self renderProcessUploadOn: html index: index].

		html div id: 'add-new-import-form';
			with: [html div id: 'add-new-form-button'; with: [self renderAddNewImportFormButtonOn: html].
					html div id: 'remove-new-form-button'; with: [self renderRemoveImportFormButtonOn: html].
					self renderImportAllButtonOn: html].

	]! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
renderImportAllButtonOn: html
	| cssClass |

	cssClass := (numberOfProcess = 1) ifTrue: ['import-all-button-1'] ifFalse: ['import-all-button-2'].

	html div class: cssClass; with: [
		(selectedUploads size = numberOfProcess) ifFalse: [^self].
					html anchor callback: [self importBizagiFiles];
						with: [html image url: (SEWAFFileLibrary / #actionsdocumentsaveasiconPng); 
								altText: ('Import All Files' translateFor: self session user); 
								title: ('Import All Files' translateFor: self session user)].
	]! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 03/02/2016 12:44'!
renderProcessUploadOn: html index: index

	html div class: 'centered-unique-form float-left';
		with: [
				html form multipart; 
					class: 'height300';
					with: [
						html fieldSet with:[
							html legend with: [html strong: ('XPDL Upload Form' translateFor: self session user)].
							html label attributeAt: 'for' put: 'orbeonApp'; with: ('Orbeon Application' translateFor: self session user).
							html select list: (#('-'), (orbeonApplications collect: [:each | each applicationName])) asSortedCollection; 
								attributeAt: 'id' put: 'orbeonApp';
								title: ('Available Form Applications' translateFor: self session user);
								onChange: 'submit()';
								callback: [:value | uploadProcesses at: index put: value ];
								selected: (uploadProcesses at: index ifAbsent: [nil]).
								html label attributeAt: 'for' put: 'processName'; with: ('Process Name' translateFor: self session user).
								html textInput attributeAt: 'id' put: 'processName';
									callback: [:value | processesNames at: index put: value];
									with: (processesNames at: index ifAbsent: ['']).
							self renderUploadComponentOn: html index: index]]].! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
renderRemoveImportFormButtonOn: html

	"at least one import form has to be rendered"
	(numberOfProcess > 1) ifFalse: [^self]. 

	html anchor callback: [self removeImportProcessForm];
					with: [html image url: (SEWAFIconLibrary / #delete132Png); 
								altText: ('Remove Import Process Form' translateFor: self session user); 
								title: ('Remove Import Process Form' translateFor: self session user)].! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/09/2015 13:41'!
renderUploadComponentOn: html index: index

	html label attributeAt: 'for' put: 'selectFile'; with: ('Select File' translateFor: self session user).
	html fileUpload attributeAt: 'id' put: 'selectFile'; 
		callback: [ :value | self receiveFile: value index: index]. "the user upload the XPDL file"

	html break.

	((index ~= 1) and: [(selectedUploads includesKey: index - 1) not]) ifTrue: [^self]. "the previous file was NOT uploaded"

	(selectedUploads includesKey: index)
	ifFalse: [html submitButton: ('Send File [' translateFor: self session user), index printString, ']']
	ifTrue:[html strong with: [html paragraph with: (selectedUploads at: index)].
			(fileFormats includesKey: (selectedUploads at: index)) "file format error"
			ifTrue: [html paragraph class: 'error-text';
				with: (fileFormats at: (selectedUploads at: index))].
			invalidFormatError notNil ifTrue: [html paragraph class: 'error-text'; with: invalidFormatError].
	].! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
selectedUploads
	^selectedUploads! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
selectedUploads: newValue
	selectedUploads := newValue! !

!WAXpdlImporterBrowser methodsFor: 'other' stamp: 'BrunoBB 12/09/2015 10:23'!
sewafImportReportTable: anOrderedCollection

	^(SewafTableReport summary: 'XPDL Import Report')
		rows: anOrderedCollection; "get collection elements"
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #type title: 'Type');
						add: (SewafReportColumn selector: #title title: 'Title');
						add: (SewafReportColumn selector: #description title: 'Description');
						yourself);
		rowColors: #(white lightgray);
		rowPeriod: 1;
		yourself! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
upload
	^upload! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
upload: newValue
	upload := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 11:50'!
uploadProcesses
	^uploadProcesses! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 11:50'!
uploadProcesses: newValue
	uploadProcesses := newValue! !

SewafLateralListComposite subclass: #WAProcessDefinitionBrowser
	instanceVariableNames: 'mode categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAProcessDefinitionBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 07/02/2015 12:37'!
categories
	^categories! !

!WAProcessDefinitionBrowser methodsFor: 'Updating' stamp: 'BrunoBB 07/02/2015 12:37'!
categories: newValue
	categories := newValue! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 03/06/2016 17:09'!
downloadProcessMap

	^self downloadProcessMapOf: self selectedLateralItem! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 03/06/2016 17:10'!
downloadProcessMapOf: aBpmProcessDefinition
	| stream |

	stream := PrintStream on: String new.

	stream nextPutAll: '<?xml version="1.0" encoding="utf-8"?>', String lf,aBpmProcessDefinition xmlString.

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/csv'; 
                                        fileName: (aBpmProcessDefinition processName, '.xpdl'); 
                                        yourself)].

	aBpmProcessDefinition subProcess do: [:each | self downloadProcessMapOf: each]! !

!WAProcessDefinitionBrowser methodsFor: 'categories' stamp: 'BrunoBB 12/15/2015 10:11'!
filterProcessDefinitionByCategory: aBpmProcessDefinitionCategory

	searchApplied := true.
	searchResult := lateralCollection select: [:each | aBpmProcessDefinitionCategory includes: each]! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 06/27/2015 13:10'!
getCurrentCollection

	searchApplied ifFalse: [^lateralCollection].

	^searchResult! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 12/10/2015 06:37'!
getFormDefinitionList
	| allFormsNames |

	allFormsNames := OrderedCollection new.

	lateralCollection do: [:each | allFormsNames addAll: each getTaskNames].

	^self viewAllArray, allFormsNames asSet asSortedCollection

"	^#('-View All-'), (allFormsNames asSet asSortedCollection) "! !

!WAProcessDefinitionBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 06/27/2015 13:40'!
getIconNameFormItem 

	^#pageprocess32Png! !

!WAProcessDefinitionBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 12/10/2015 06:47'!
getTextForItem: aLateralListItem

	^aLateralListItem processName! !

!WAProcessDefinitionBrowser methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 16:28'!
initialize

	super initialize.

	mode := #normal.
	searchAvailable := false.
	categories := OrderedCollection new.

	self setShowToElementNamed: 'search-area'.

	batchedList := SewafLateralBatchedList parentComponent: self.
	batchedList batchSize: 5;
		navigationCssClass: 'batch-div-lateral-top'.! !

!WAProcessDefinitionBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/05/2015 15:45'!
mode
	^mode! !

!WAProcessDefinitionBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/05/2015 15:45'!
mode: newValue
	mode := newValue! !

!WAProcessDefinitionBrowser methodsFor: 'categories' stamp: 'BrunoBB 12/15/2015 10:11'!
onProcessCategoryClicked: aBpmProcessDefinitionCategory

	self hasSelectedLateralItem ifFalse: [^self filterProcessDefinitionByCategory: aBpmProcessDefinitionCategory].

	(aBpmProcessDefinitionCategory includes: selectedLateralItem)
	ifTrue: [aBpmProcessDefinitionCategory remove: selectedLateralItem]
	ifFalse: [aBpmProcessDefinitionCategory add: selectedLateralItem]! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 06/13/2015 08:39'!
registerProcessType: value

	searchValues at: 'process-type' put: value.! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 03/12/2016 16:21'!
removeProcessDefinition! !

!WAProcessDefinitionBrowser methodsFor: 'categories' stamp: 'BrunoBB 07/03/2015 12:25'!
renderCategoriesListOn: html

	categories do: [:each | 
		html anchor callback: [self onProcessCategoryClicked: each]; 
			class: 'category-label';
			style: 'background-color:', each color;
			with: [html output: each name]].! !

!WAProcessDefinitionBrowser methodsFor: 'categories' stamp: 'BrunoBB 12/15/2015 10:12'!
renderCustomItemElementOn: html forItem: aBpmProcessDefinition

	(self session user getProcessDefinitionCategoriesFor: aBpmProcessDefinition) do: [:each | 
		html div class: 'category-circle'; style: 'background-color: ', each color;
			with: [html output: each name first].
	].! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 03/12/2016 16:27'!
renderDeleteProcessDefintionOn: html

	html div class: 'float-left margin-left-5px'; with: [
		html anchor callback: [self removeProcessDefinition]; 
						with: [html image url: (SEWAFIconLibrary / #remove24Png); 
												title: ('Remove Process Definition' translateFor: self session user); 
												altText: ('Remove Process Definition' translateFor: self session user)]
	]! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 09/28/2015 16:52'!
renderFormDefinitionComboOn: html

	html label attributeAt: 'for' put: 'formDefinition'; with: ('Form' translateFor: self session user).

	html select "Form Definition List" class: 'search-section-width-200';
		attributeAt: 'id' put: 'formDefinition';
		list: self getFormDefinitionList;
		callback: [:value | searchValues at: 'form-type' put: value];
		selected: (searchValues at: 'form-type' ifAbsent: ['']).! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 03/12/2016 16:29'!
renderItemComponentOn: html

	selectedLateralItem canDelete ifTrue: [self renderDeleteProcessDefintionOn: html].

	html unorderedList with:[
		selectedLateralItem getTransitions do: [:transitionDefinition |
			html listItem with: [self renderTransitionOn: html forTransition: transitionDefinition.
										html horizontalRule.].
		].
	].

	html div id: 'artifact-definitions'; with: [
		selectedLateralItem getOrderedTasks do: [:taskDefinition | 
			html div class: 'artifact-definition'; with: [html output: taskDefinition printNameAndDefinitionType]]
	].! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 06/27/2015 14:45'!
renderItemDescriptionAditionalDataOn: html

	html span: [html strong: ('Can be Modified:' translateFor: self session user)]. 
	html output: selectedLateralItem canModifyPathDefinition.
	html span: [html strong: ('Has Finished Processes:' translateFor: self session user)]. 
	html output: selectedLateralItem hasFinishedProcesses.! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 12/10/2015 06:48'!
renderItemDescriptionSecondaryDataOn: html

	html span with: [html strong: ('Process Id:' translateFor: self session user)].
	html output: selectedLateralItem processId.
	html span with: [html strong: ('Version:' translateFor: self session user)].
	html output: selectedLateralItem version.
	html span with: [html strong: ('Application:' translateFor: self session user)].
	html output: selectedLateralItem applicationName.
	html span with: [html strong: ('Parent Process:' translateFor: self session user)].
	html output: selectedLateralItem getParentProcessName.! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 03/06/2016 17:01'!
renderItemDescriptionTitleOn: html

	html output:  selectedLateralItem processName.

	html anchor 
		callback: [self downloadProcessMap]; 
		with: [html image url: (SEWAFIconLibrary / #documentflowchart24Png); 
					title: ('Process Map' translateFor: self session user);
					altText: ('Process Map' translateFor: self session user)].! !

!WAProcessDefinitionBrowser methodsFor: 'lateral process list' stamp: 'BrunoBB 06/27/2015 13:59'!
renderLateralItemDetailsOn: html for: aLateralItem

	html strong with: [html output: aLateralItem processId].
	html strong with: [html output: aLateralItem version].
	html strong with: [html output: aLateralItem applicationName].! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 12/10/2015 08:56'!
renderProcessTypeComboOn: html

	html label attributeAt: 'for' put: 'processType'; with: ('Process Type' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'processType';
		list: self viewAllArray, (lateralCollection collect: [:each | each processName]) asSet asSortedCollection;
		onChange: 'submit()';
		callback: [:value | self registerProcessType: value];
		selected: (searchValues at: 'process-type' ifAbsent: ['']).! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/06/2016 16:29'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	self searchPanelIsRegular 
	ifTrue: [self renderSearchRegularPanelOn: html]
	ifFalse: [self renderSearchCategoriesPanelOn: html]! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/12/2016 14:10'!
renderSearchCategoriesPanelOn: html

	html form with: [ 
		html fieldSet with: [
			self renderSwitchWindowOn: html.
			html legend class: 'top-search-legend'; with: ('Search Process' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label with: ('Category Name' translateFor: self session user).
				html textInput callback: [:value | searchValues at: 'category-name' put: value].].
			html div class: 'top-search-div'; with: [self renderCategoriesListOn: html].
			html div id: 'top-search-filters-one'; with: [
				html submitButton
					style: 'margin-top: 25px';
					callback: [self searchMatchingCategories]; 
					with: ('Search' translateFor: self session user).].
		].
].! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/10/2016 16:17'!
renderSearchRegularPanelOn: html

	html form with: [ 
		html fieldSet with: [
			self renderSwitchWindowOn: html.
			html legend class: 'top-search-legend'; with: ('Search Process' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'processId'; with: ('Process Id' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'processId';
					callback: [:value | searchValues at: 'id' put: value].
			].
			html div class: 'top-search-div'; with: [self renderProcessTypeComboOn: html].
			html div class: 'top-search-div'; with: [self renderFormDefinitionComboOn: html].
			html div id: 'top-search-filters-two'; with: [
				self renderSearchSubmitButtonOn: html].
		].
]! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/10/2016 16:19'!
renderSearchSubmitButtonOn: html

	html submitButton 
		style: 'margin-top: 35px;';
		callback: [self searchMatchingProcesses]; 
		with: ('Search' translateFor: self session user).! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 07/01/2015 13:52'!
renderSwitchWindowOn: html

	html div id: 'top-search-switch-icon'; with: [
		html anchor 
			callback: [searchPanelName := (searchPanelName = #search) ifTrue: [#categories] ifFalse: [#search]];
			with: [
				html div with: [
					html image url: (SEWAFIconLibrary / #ezswitchuser16Png); 
						altText: 'Switch Window'; 
						title: 'Switch Window'.
				].
		].
	].! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 06/07/2015 13:59'!
renderTransitionOn: html forTransition: transitionDefinition

	html output: transitionDefinition printData! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/06/2016 17:47'!
searchByFormType

	searchResult := lateralCollection select: [:each | each getOrderedTasksNames includes: (searchValues at: 'form-type')].! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 06/27/2015 13:11'!
searchByProcessId

	searchResult := lateralCollection select: [:each | each processId printString = (searchValues at: 'id')].! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/06/2016 17:50'!
searchByProcessType

	searchResult := lateralCollection select: [:each | each processName = (searchValues at: 'process-type')].! !

!WAProcessDefinitionBrowser methodsFor: 'categories' stamp: 'BrunoBB 12/15/2015 10:11'!
searchMatchingCategories

	categories := (BpmProcessDefinitionCategory getCategoriesFor: self session user) select: [:each | 
		(searchValues at: 'category-name' ifAbsent: ['']) match: each name].! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 09/28/2015 16:48'!
searchMatchingProcesses

	searchApplied := true.

	((searchValues includesKey: 'id') and: [(searchValues at: 'id') notEmpty])
	ifTrue: [^self searchByProcessId].

	((searchValues includesKey: 'process-type') and: [(searchValues at: 'process-type') ~= self viewAllText])
	ifTrue: [^self searchByProcessType].

	((searchValues includesKey: 'form-type') and: [(searchValues at: 'form-type') ~= self viewAllText])
	ifTrue: [^self searchByFormType].

	^searchResult := lateralCollection! !

SEWAFApplicationPortal subclass: #WAProcessBackofficePortal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:32'!
applicationIcon

	^SEWAFIconLibrary / #applicationsettings48Png! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:32'!
applicationName

	^'Flow Backoffice'! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 12/10/2015 06:31'!
getDefinitionCollection

	^self session user getProcessDefinitionLatestVersions! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 06/05/2015 06:17'!
initialize

	super initialize.

	self initializeNavigation.! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 02/29/2016 08:51'!
initializeNavigation
	| subMenu1 subMenu2 subMenu3 subMenu4 |

	navigation := SewafPortalMenu new iconLibrary: SEWAFIconLibrary.
	subMenu1 := (SewafSubMenuItem label: 'Processes' icon: #process48Png)
		addItem: (SewafCommandItem label: 'Manage Processes Definitions' command: #openDefinitionsManager);
		addItem: (SewafCommandItem label: 'Define New Process' command: #openBizagiManager);
		addItem: (SewafCommandItem label: 'Monitor Processes' command: #openProcessRadar);
		addItem: (SewafCommandItem label: 'Monitor Users' command: #openUsersRadar);
		addItem: (SewafCommandItem label: 'Process Categories' command: #openProcessCategoryManager);
		yourself.
	subMenu2 := (SewafSubMenuItem label: 'Applications' icon: #forms48Png)
		addItem: (SewafCommandItem label: 'Manage Applications' command: #openApplicationManager);
		addItem: (SewafCommandItem label: 'Manage Orbeon Forms' command: #openFormManager);
		yourself.
	subMenu3 := (SewafSubMenuItem label: 'Users-Roles' icon: #usersettings48Png)
		addItem: (SewafCommandItem label: 'Manage Users' command: #openUsersManager);
		addItem: (SewafCommandItem label: 'Manage Roles' command: #openRolesManager);
		yourself.
	subMenu4 := (SewafSubMenuItem label: 'Configuration' icon: #serversetting48Png)
		addItem: (SewafCommandItem label: 'Server Setup' command: #openServerSetup);
		addItem: (SewafCommandItem label: 'Login Mode' command: #openLoginMode);
		addItem: (SewafCommandItem label: 'Change Password' command: #openChangePassword);
		addItem: (SewafCommandItem label: 'Set Language' command: #openLanguageConfiguration);
		addItem: (SewafCommandItem label: 'Internationalization' command: #openInternationalizationManager);
		yourself.
	navigation addItem: subMenu1;
		addItem: subMenu2;
		addItem: subMenu3;
		addItem: subMenu4.! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:43'!
logout

	self session logout.	
	self session unregister.
	self requestContext redirectTo: (self getGemStoneServerConfiguration gemstoneIP, '/orbeonBackoffice')! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 02/26/2016 13:56'!
openApplicationManager

	(arena isKindOf: BpmApplicationManagerComposite)
	ifTrue: [^arena].

	^BpmApplicationManagerComposite parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 03/05/2016 09:50'!
openBizagiManager

	(arena isKindOf: WAXpdlImporterBrowser)
	ifTrue: [^arena].

	^WAXpdlImporterBrowser new orbeonApplications: self session user getVisibleApplications.! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 06/08/2015 14:20'!
openChangePassword

	(arena isKindOf: FormUserPasswordComposite)
	ifTrue: [^arena].

	^FormUserPasswordComposite parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 06/07/2015 16:38'!
openDefinitionsManager
	| subComponent |

	(arena isKindOf: WAProcessDefinitionBrowser)
	ifTrue: [arena mode: #normal.
		^arena parent: self collection: self getDefinitionCollection].

	subComponent := WAProcessDefinitionBrowser parent: self collection: self getDefinitionCollection.
	
	subComponent mode: #normal.

	^subComponent! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 06/08/2015 11:36'!
openFormManager

	(arena isKindOf: OrbeonFormsUpdateComposite)
	ifTrue: [^arena].

	^OrbeonFormsUpdateComposite parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 06/23/2015 13:30'!
openInternationalizationManager

	(arena isKindOf: WAInternationalizationManager)
	ifTrue: [^arena].

	^WAInternationalizationManager parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 06/26/2015 14:14'!
openLanguageConfiguration

	(arena isKindOf: BkUserLanguageComposite)
	ifTrue: [^arena].

	^BkUserLanguageComposite parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 06/08/2015 14:24'!
openLoginMode

	(arena isKindOf: FormLoginModeComposite)
	ifTrue: [^arena].

	^FormLoginModeComposite parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 06/30/2015 14:12'!
openProcessCategoryManager

	(arena isKindOf: WAManageFormProcessCategory)
	ifTrue: [^arena].

	^WAManageFormProcessCategory parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 12/20/2015 15:23'!
openProcessRadar

	(arena isKindOf: WAOrbeonRadarProcessComposite2)
	ifTrue: [^arena].

	^WAOrbeonRadarProcessComposite2 parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 12/18/2015 14:25'!
openRolesManager

	(arena isKindOf: FormProcessRoleComposite)
	ifTrue: [^arena].

	^FormProcessRoleComposite parent: self on: BpmFrontOfficeRole new.! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 02/03/2016 09:37'!
openServerSetup

	(arena isKindOf: FormServerConfigurationComposite)
	ifTrue: [^arena].

	^(FormServerConfigurationComposite parent: self)
		yourself! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 12/18/2015 14:10'!
openUsersManager

	(arena isKindOf: FormProcessUserComposite)
	ifTrue: [^arena].

	^FormProcessUserComposite parent: self on: BpmUser new.! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 12/20/2015 14:56'!
openUsersRadar

	(arena isKindOf: WAOrbeonRadarUserComposite2)
	ifTrue: [^arena].

	^WAOrbeonRadarUserComposite2 parent: self! !

!WAProcessBackofficePortal methodsFor: 'style' stamp: 'BrunoBB 03/12/2016 16:28'!
style

^'/* Smart Devices*/
@media (max-width: 800px) {                  
   .smart-hide-width {
      display: none !!important;
   }
}
@media (max-height: 450px) {                  
   .smart-hide-height {
      display: none !!important;
   }
}
/* NEW CSS - REFACTORIZED */
/* START: HTML GENERAL */
body, html, main {
	margin: 0;
	width: 100%;
	height: 100%;
	overflow-y: hidden;
	background-color: #BCBCBC;
}
#screen-all {
	height: 100%;
}
/* END: HTML GENERAL */
/* START: TOP AREA */
#top-area {
	display: inline-flex;
	width: 100%;
	background-color: gray;
	padding-top: 2px;
}
#top-app-icon-area {
	display: inline-flex;
	padding-top: 15px;
	padding-left: 10px;
	width: 20%;
}
#top-app-icon-area h1{
	margin-top: 5px;
	color: gainsboro;
}
#top-logout a {
	text-decoration: none;
}
#top-logout output {
	font-size: 90%;
}
#top-menu-area {
	width: 80%;
	margin-top: 5px;
}
#top-search-show-hide-area {
	display: inline-flex;	
}
#top-submenu-area {
	height: 40px;
	background-color: lightgray;
}
.top-area-close-icon {
	float: right;
	margin-top: 3px;
	margin-right: 5px;
}
.top-menu-item {
	float: left;
	margin-left: 5%;
}
.top-menu-item a {
	color: white;
	text-decoration: none;
}
.top-menu-item a output {
	font-size: 120%;
}
.top-menu-item img {
	display: block;
	margin-left: auto;
	margin-right: auto;
}
.top-menu-item-triangle {
	border-style: solid;
	border-width: 0px 10px 10px;
	border-color: transparent transparent #D3D3D3;
	color: #FFF;
	width: 0px;
	height: 0px;
	margin-left: auto;
	margin-right: auto;
}
.top-sub-item-selected output {
	font-family: Times New Roman;
	font-size: 20px;
	color: rgb(64, 64, 64);
}
.top-sub-item-selected a, .top-sub-item-unselected a {
	text-decoration: none;
}
.top-sub-item-selected, .top-sub-item-unselected {
	float: left;
	padding-top: 10px;
	margin-left: 10px;
	margin-right: 30px;
}
.top-sub-item-unselected output {
	font-family: Times New Roman;
	font-size: 20px;
	color: #808080;
}
.top-sub-item-selected, .top-sub-item-unselected output:hover {
	color: rgb(64, 64, 64);
}
/* END: TOP AREA */
/* START: BOTTOM AREA */
/* END: BOTTOM AREA */
/* START: COMPONENT AREA */
#component-area {
	background-color: #BCBCBC;
	width: 100%;
	height: 100%;
}
#component-area hr {
	margin-top: 0px;
	margin-bottom: 0px;
}
/*START: SEARCH AREA*/
#top-search-area {
	width: 100%;
	display: inline-flex;
}
.top-search-area-box-shadow {
	box-shadow: 2px 2px 2px 0px rgba(11, 10, 10, 0.8);
}
#top-search-switch-icon {
	display: inline-flex;
	float: right;
	margin-top: -25px;
}
#top-search-area form {
	width: 100%;
}
#top-search-area form fieldset {
	border-radius: 6px;
	margin-bottom: 0px;
	padding-bottom: 5px;
	border: none;
}
#top-search-area form fieldset label {
	margin-right: 10px;
}
#top-search-area form fieldset input[type="text"], 
#top-search-area form fieldset select {
	border-radius: 6px;
	margin-right: 20px;
	border-color: darkgray;
	width: 100%;
}
.top-search-div {
	float: left;
	width: 200px;
	margin-right: 15px;
}
.top-search-legend {
	font-weight: bold;
	text-decoration: underline;
}
#top-search-filters-one {
	display: inline-block;
	width: 200px;
	margin-top: -5px;
}
#top-search-filters-two {
	display: inline-block;
	width: 200px;
	margin-top: -15px;
}
#top-search-filters-one input {
	border-radius: 6px;
	margin-right: 20px;
	border-color: #A9A9A9;
}
#top-search-filters-two input {
	border-radius: 6px;
	margin-right: 20px;
	border-color: #A9A9A9;
}
.top-search-vertical-line {
	width: 8px;
	background-color: lightgray;
	float: left;
	margin-right: 10px;
}
/*END: SEARCH AREA*/
/*START: INNER COMPONENTS*/
#add-new-import-form {
	display: inline-flex;
}
#add-new-form-button {
	padding: 10px;
}
#add-rol-button {
	float: left;
	margin-top: 20px;
}
#add-user-button {
	float: left;
	margin-top: 40px;
}
#applications-list {
	float: left;
	margin-left: 10px;
}
#applications-list select {
	width: 300px;
}
.artifact-definition {
    padding: 5px 15px 15px;
    float: left;
    margin: 10px;
    border-radius: 10px;
    background-color: #868686;
    width: 20%;
    height: 20%;
    overflow-y: auto;
}
#artifact-definitions {
    display: inline-block;
	width: 100%;
}
.category-circle {
	width: 20px;
	height: 20px;
	border-radius: 10px;
	float: left;
	margin-bottom: 3px;
	margin-left: 2px;
	text-align: center;
}
.category-label {
	float: right;
	text-decoration: none;
	color: white;
	border-radius: 10px;
	padding-left: 5px;
	padding-right: 5px;
	margin-left: 5px;
	margin-right: 5px;
}
.error-text {
	color: red;
}
#forms-operations {
	float: left;
	width: 200px;
}
#forms-operations input {
	border-radius: 10px;
	margin-left: 10px;
	margin-bottom: 10px;
}
.hide-lateral-left-list {
	float: left;
}
.import-all-button-1 {
	padding: 10px;
}
.import-all-button-2 {
	margin-left: 310px;
}
#import-forms {
	overflow-y: auto;
	height: 620px;
	display: inline-block;
}
#internationalization {
}
#internationalization fieldset {
	border: medium none;
}
#internationalization label, #internationalization input, #internationalization select {
	width: 200px;
	border-radius: 10px;
	margin-right: 15px;
}
#inter-current-dictionary {
	height: 480px;
	margin-left: auto;
	margin-right: auto;
	width: 90%;
	overflow-y: auto;
}
#inter-current-dictionary output {
	color: #66650B;
}
#inter-current-dictionary span {
	color: rgb(14, 79, 101);
}
#item-customized-component ul {
	list-style-type: none;
}
.lateral-left-list {
	width: 19.5%;
	display: inline-block;
	height: 100%;
	font-size: 90%;
	box-shadow: 2px 2px 2px 0px rgba(11, 10, 10, 0.8) inset;
}
.lateral-left-list ul {
	list-style-type: none;
	padding-left: 2px;
}
.lateral-left-list a {
	text-decoration: none;
	color: black;
}  
.lateral-left-list ul li {
	margin-bottom: 10px;
}
.lateral-left-list-icon {
	width: 32px;
	float: left;
	padding-left: 5px;
	padding-top: 5px;
}
.lateral-left-list-item-selected {
	background-color: beige;
	border-radius: 10px;
	padding-left: 10px;
}
.lateral-left-list-item-unselected {
}
.lateral-left-list-item-summary-data {
	display: inline-block;
	color: rgb(37, 46, 146);
}
.lateral-left-list-item-summary-data output {
	display: block;
	margin-left: auto;
	margin-right: auto;
}
.lateral-left-list-item-title-selected {
	font-size: 150%;
}
.lateral-left-list-item-title-unselected {
	font-size: 150%;
}
.lateral-right-component-additional-data {
	text-align: center;
}
.lateral-right-component-additional-data span {
	font-style: italic;
	margin-right: 5px;
	margin-left: 15px;
	color: #8A8A59;
}
.lateral-right-component-additional-data output {
	color: darkblue;
}
.lateral-right-component {
	height: 100%;
	float: right;
	background-color: #BCBCBC;
}
.lateral-right-component-description {
	background-color: #E4E49E;
	padding-bottom: 15px;
	margin-left: 2px;
    margin-top: 2px;
    margin-right: 2px;
}
.lateral-right-component-main-data {
	font-size: 150%;
	text-align: center;
	padding-top: 1px;
}
.lateral-right-component-main-data a {
	float: right;
}
.lateral-right-component-width80 {
	width: 80.5%;
}
.lateral-right-component-width100 {
	width: 100%;
}
.lateral-right-component-secondary-data {
	text-align: center;
}
.lateral-right-component-secondary-data span {
	font-style: italic;
	margin-right: 5px;
	margin-left: 15px;
	color: #8A8A59;
}
.lateral-right-component-secondary-data output {
	color: darkblue;
}
.list-lateral-element {
	width: 90%;
}
.list-lateral-element-custom {
	float: right;
	width: 10%;
}
.list-lateral-item {
	display: flex;
	margin-bottom: 5px;
	margin-top: 5px;
}
.max-width-td {
	max-width: 600px;
}
#orbeon-definitions-list {
	width: 50%;
	margin-left: auto;
	margin-right: auto;
}
#orbeon-list-application {
	padding-top: 20px;
	width: 57%;
	margin-left: auto;
	margin-right: auto;
}
#process-definition {
	height: 100%;
	box-shadow: 2px 2px 2px 0px rgba(11, 10, 10, 0.8) inset;
}
#radar {
	display: inline-flex;
}
#remove-new-form-button {
	padding-top: 10px;
}
.right-sub-component {
	margin-left: 10px;
	margin-top: 10px;
	overflow-y: auto;
	height: 440px;
}
.right-sub-component ul {
	list-style-type: none;
}
#rols-users {
	padding-bottom: 20px;
}
#rols-and-users {
	float: left;
	display: inline-flex;
}
#system-rols {
	display: inline-flex;
	float: left;
}
#system-users {
	display: inline-flex;
	float: left;
}
.unique-centered-table {
	margin-left: auto;
	margin-right: auto;
	border: 2px solid #000;
	border-radius: 10px;
	margin-top: 30px;
}
.unique-centered-table-width30 {
	width: 30%;
}
.unique-centered-table-width70 {
	width: 70%;
}
.unique-centered-table  table {
	width: 100%;
}
.unique-centered-table fieldset {
	border: 0px none;
	margin-left: auto;
	margin-right: auto;
	width: 150px;
	margin-top: 20px;
}
.unique-centered-table fieldset  input {
	border-radius: 10px
}
#users-and-rols {
	float: left;	
}
#users-configuration {
}
#user-rols {
}
#users-to-add {
	float: left;
}
#users-to-add input {
	border-radius: 10px;
}
#users-to-add input[type="submit"] {
	margin-top: 20px;
}
#users-to-add-to-role {
	float: left;
}
#users-to-add-to-role input {
	border-radius: 10px;
}
#users-to-add-to-role input[type="submit"] {
	margin-top: 20px;
}
.width-6-percent {
	width: 6%;
}
/*END: INNER COMPONENTS*/
/* END: COMPONENT AREA */
/*   ESTILES IN TEST   */
.batch {
	border-radius: 5px;
	padding: 5px;
	background: beige;
	margin-right: 2px;
	margin-left: 2px;
	display: inline-block;
    text-decoration: none;
    color: black;
}
.batch-div-bottom {
	margin-top: -18px;
	margin-left: 25px;
}
.batch-div-bottom-with-button {
	margin-top: -78px;
	margin-left: 25px;
}
.batch-div-lateral-top {
	margin-top: 10px;
	margin-bottom: -8px;
	margin-left: 5px;
}
.centered-unique-form {
	color: black;
	background-color: #BCBCBC;
	font-size: 18px;
	font-style: normal;
	border-radius: 5px;
	border: 1px solid #BCBCBC;
	border-width: 1px 1px 3px;
	margin-bottom: 10px;
	padding: 10px;
}
.centered-unique-form form {
	max-width: 350px;
	margin: 10px auto;
	padding: 10px 20px;
	background: #898a8a;
	border-radius: 8px;
}
.centered-unique-form fieldset {
	margin-bottom: 5px;
	border: none;
}
.centered-unique-form h1 {
	margin: 0 0 30px 0;
	text-align: center;
}
.centered-unique-form input[type="text"],
.centered-unique-form input[type="password"], 
.centered-unique-form input[type="date"],
.centered-unique-form input[type="datetime"], 
.centered-unique-form input[type="email"],
.centered-unique-form input[type="number"], 
.centered-unique-form input[type="search"],
.centered-unique-form input[type="tel"], 
.centered-unique-form input[type="time"],
.centered-unique-form input[type="url"], 
.centered-unique-form textarea, 
.centered-unique-form select {
	background: rgba(255,255,255,0.1);
	font-size: 16px;
	height: auto;
	margin: 0;
	outline: 0;
	width: 100%;
	background-color: white;
	color: black;
	box-shadow: 0 1px 0 rgba(0,0,0,0.03) inset;
	margin-bottom: 10px;
}
.centered-unique-form input[type="radio"], 
.centered-unique-form input[type="checkbox"] {
	margin: 0 4px 8px 0;
}
.centered-unique-form select {
	padding: 6px;
	border-radius: 2px;
}
.centered-unique-form label {
	display: block;
	margin-bottom: 8px;
}
.centered-unique-form label.light {
	font-weight: 300;
	display: inline;
}
/* BASIC BLOCK STYLES */
/* BASIC BLOCK STYLES */
.display-block {
	display: block;
}
.display-inline-block {
	display: inline-block;
}
.float-left {
	float: left;
}
.float-none {
	float: none;
}
.height180 {
	height: 180px;
}
.height250 {
	height: 250px;
}
.height300 {
	height: 300px;
}
.margin-left-5px {
	margin-left: 5px;
}
.margin-right-20per {
	margin-right: 20%;
}
.margin-top-15px {
	margin-top: 15px;
}
.margin-top-10px {
	margin-top: 10px;
}
.margin-bottom-15px {
	margin-bottom: 15px;
}
.margin-bottom-10px {
	margin-bottom: 10px;
}
.underline {
	text-decoration: underline;
}
/* RIGHT LATERAL TABLE STYLES */
.default-gray-table table {
	color:black;
	font-size:18px;
	background:#898a8a;
	margin:20px;
	border:#ccc 1px solid;

	-moz-border-radius:3px;
	-webkit-border-radius:3px;
	border-radius:3px;

	-moz-box-shadow: 0 1px 2px #d1d1d1;
	-webkit-box-shadow: 0 1px 2px #d1d1d1;
	border-radius: 10px;
	padding-bottom: 2px;
	padding-left: 2px;
	padding-right: 2px;
}
.default-gray-table table a:link {
	color: #666;
	font-weight: bold;
	text-decoration:none;
}
.default-gray-table table a:visited {
	color: #999999;
	font-weight:bold;
	text-decoration:none;
}
.default-gray-table table a:active,
.default-gray-table table a:hover {
	color: black;
	text-decoration:underline;
}
.default-gray-table table th {
	padding:10px 15px 5px 15px;
	background-color: #898a8a;
}
.default-gray-table table th:first-child {
	text-align: left;
	padding-left:20px;
}
.default-gray-table table tr:first-child th:first-child {
	-moz-border-radius-topleft:5px;
	-webkit-border-top-left-radius:5px;
	border-top-left-radius:5px;
}
.default-gray-table table tr:first-child th:last-child {
	-moz-border-radius-topright:3px;
	-webkit-border-top-right-radius:3px;
	border-top-right-radius:3px;
}
.default-gray-table table tr {
	text-align: center;
	padding-left:20px;
}
.default-gray-table table td:first-child {
	text-align: left;
	padding-left:20px;
	border-left: 0;
}
.default-gray-table table td {
	padding: 5px;
}
.default-gray-table table tr.even td {
	background: #f6f6f6;
	background: -webkit-gradient(linear, left top, left bottom, from(#f8f8f8), to(#f6f6f6));
	background: -moz-linear-gradient(top,  #f8f8f8,  #f6f6f6);
}
.default-gray-table table tr:last-child td {
	border-bottom:0;
}
.default-gray-table table tr:first-child td:first-child {
	-moz-border-radius-topleft:5px;
	-webkit-border-top-left-radius:5px;
	border-top-left-radius:5px;
}
.default-gray-table table tr:first-child td:last-child {
	-moz-border-radius-topright:5px;
	-webkit-border-top-right-radius:5px;
	border-top-right-radius:5px;
}
.default-gray-table table tr:last-child td:first-child {
	-moz-border-radius-bottomleft:5px;
	-webkit-border-bottom-left-radius:5px;
	border-bottom-left-radius:5px;
}
.default-gray-table table tr:last-child td:last-child {
	-moz-border-radius-bottomright:5px;
	-webkit-border-bottom-right-radius:5px;
	border-bottom-right-radius:5px;
}
.default-gray-table table tr:hover td {
	background: #f2f2f2;
	background: -webkit-gradient(linear, left top, left bottom, from(#f2f2f2), to(#f0f0f0));
	background: -moz-linear-gradient(top,  #f2f2f2,  #f0f0f0);	
}'! !
